## glibc 2.43

=== benchtests/Makefile ===
# Copyright (C) 2013-2026 Free Software Foundation, Inc.
# Copyright The GNU Toolchain Authors.
# This file is part of the GNU C Library.

# The GNU C Library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.

# The GNU C Library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.

# You should have received a copy of the GNU Lesser General Public
# License along with the GNU C Library; if not, see
# <https://www.gnu.org/licenses/>.

# Makefile for benchmark tests.  The only useful target here is `bench`.
# Add benchmark functions in alphabetical order.

subdir := benchtests

include ../Makeconfig

bench-math := \
  acos \
  acosf \
  acosh \
  acoshf \
  acospi \
  acospif \
  asin \
  asinf \
  asinh \
  asinhf \
  asinpi \
  asinpif \
  atan \
  atan2 \
  atan2f \
  atan2pi \
  atan2pif \
  atanf \
  atanh \
  atanhf \
  atanpi \
  atanpif \
  cbrt \
  cbrtf \
  ceil \
  ceilf \
  cos \
  cosf \
  cosh \
  coshf \
  cospi \
  cospif \
  erf \
  erfc \
  erfcf \
  erff \
  exp \
  exp10 \
  exp10f \
  exp10m1 \
  exp10m1f \
  exp2 \
  exp2f \
  exp2m1 \
  exp2m1f \
  expf \
  expl \
  expm1 \
  expm1f \
  floor \
  floorf \
  fma \
  fmaf \
  fmal \
  fmax \
  fmaxf \
  fmin \
  fminf \
  fmod \
  fmodf \
  frexp \
  frexpf \
  frexpl \
  hypot \
  hypotf \
  ilogb \
  ilogbf \
  isfinite \
  isinf \
  isnan \
  j0 \
  j1 \
  lgamma \
  lgammaf \
  lgammaf_r \
  llrint \
  llrintf \
  log \
  log10 \
  log10f \
  log10p1 \
  log10p1f \
  log1p \
  log1pf \
  log2 \
  log2f \
  log2l \
  log2p1 \
  log2p1f \
  logb \
  logbf \
  logf \
  lrint \
  lrintf \
  modf \
  modff \
  nearbyint \
  nearbyintf \
  pow \
  powf \
  powl \
  remainder \
  remainderf \
  rint \
  rintf \
  roundeven \
  roundevenf \
  rsqrt \
  rsqrtf \
  sin \
  sincos \
  sincosf \
  sinf \
  sinh \
  sinhf \
  sinpi \
  sinpif \
  sqrt \
  tan \
  tanf \
  tanh \
  tanhf \
  tanpi \
  tanpif \
  tgamma \
  tgammaf \
  trunc \
  truncf \
  y0 \
  y1 \
  # bench-math

ifneq (,$(filter yes,$(float96-fcts)))
bench-math += \
  cbrtl \
  # bench-math
endif

ifneq (,$(filter yes,$(float128-fcts) $(float128-alias-fcts)))
bench-math += \
  expf128 \
  ilogbf128 \
  powf128 \
  sinf128 \
  # bench-math
endif

bench-pthread := \
  pthread-locks \
  pthread-mutex-lock \
  pthread-mutex-trylock \
  pthread-mutex-trylock-recursive-throughput \
  pthread-mutex-trylock-throughput \
  pthread-spin-lock \
  pthread-spin-trylock \
  pthread_once \
  thread_create \
  # bench-pthread

bench-resolv := \
  inet_ntop_ipv4 \
  inet_ntop_ipv6 \
  # bench-resolv

LDLIBS-bench-pthread-mutex-lock += -lm
LDLIBS-bench-pthread-mutex-trylock += -lm
LDLIBS-bench-pthread-mutex-trylock-recursive-throughput += -lm
LDLIBS-bench-pthread-mutex-trylock-throughput += -lm
LDLIBS-bench-pthread-spin-lock += -lm
LDLIBS-bench-pthread-spin-trylock += -lm

bench-string := \
  ffs \
  ffsll \
  # bench-string

# String function benchmarks.
string-benchset := \
  bzero \
  bzero-large \
  memccpy \
  memchr \
  memcmp \
  memcmpeq \
  memcpy \
  memcpy-large \
  memcpy-random \
  memmem \
  memmove \
  memmove-large \
  mempcpy \
  memrchr \
  memset \
  memset-large \
  memset-random \
  memset-zero \
  memset-zero-large \
  rawmemchr \
  stpcpy \
  stpcpy_chk \
  stpncpy \
  strcasecmp \
  strcasestr \
  strcat \
  strchr \
  strchrnul \
  strcmp \
  strcoll \
  strcpy \
  strcpy_chk \
  strcspn \
  strlen \
  strlen-random \
  strncasecmp \
  strncat \
  strncmp \
  strncpy \
  strnlen \
  strpbrk \
  strrchr \
  strsep \
  strspn \
  strstr \
  strtok \
  # string-benchset

# Build and run locale-dependent benchmarks only if we're building natively.
ifeq (no,$(cross-compiling))
wcsmbs-benchset := \
  wcpcpy \
  wcpncpy \
  wcrtomb \
  wcscat \
  wcschr \
  wcschrnul \
  wcscmp \
  wcscpy \
  wcscspn \
  wcslen \
  wcsncat \
  wcsncmp \
  wcsncpy \
  wcsnlen \
  wcspbrk \
  wcsrchr \
  wcsspn \
  wmemchr \
  wmemcmp \
  wmemset \
  # wcsmbs-benchset
else
wcsmbs-benchset :=
endif

string-benchset-all := $(string-benchset) ${wcsmbs-benchset}

ifeq (no,$(cross-compiling))
# We have to generate locales
LOCALES := \
  ar_SA.UTF-8 \
  cs_CZ.UTF-8 \
  da_DK.UTF-8 \
  el_GR.UTF-8 \
  en_GB.UTF-8 \
  en_US.UTF-8 \
  es_ES.UTF-8 \
  fa_IR.UTF-8 \
  fr_FR.UTF-8 \
  he_IL.UTF-8 \
  hi_IN.UTF-8 \
  hu_HU.UTF-8 \
  is_IS.UTF-8 \
  it_IT.UTF-8 \
  ja_JP.UTF-8 \
  pl_PL.UTF-8 \
  pt_PT.UTF-8 \
  ru_RU.UTF-8 \
  si_LK.UTF-8 \
  sr_RS.UTF-8 \
  sv_SE.UTF-8 \
  tr_TR.UTF-8 \
  vi_VN.UTF-8 \
  zh_CN.UTF-8 \
  # LOCALES
include ../gen-locales.mk
endif

hash-benchset := \
  dl-elf-hash \
  dl-new-hash \
  nss-hash \
  # hash-benchset

stdlib-benchset := \
  arc4random \
  bsearch \
  random-lock \
  strtod \
  # stdlib-benchset

stdio-benchset := \
  fclose \
  # stdio-benchset

stdio-common-benchset := sprintf

math-benchset := math-inlines

ifeq (${BENCHSET},)
benchset := \
  $(hash-benchset) \
  $(math-benchset) \
  $(stdio-benchset) \
  $(stdio-common-benchset) \
  $(stdlib-benchset) \
  $(string-benchset-all) \
  # benchset
else
benchset := $(foreach B,$(filter %-benchset,${BENCHSET}), ${${B}})
endif

CFLAGS-bench-ffs.c += -fno-builtin
CFLAGS-bench-ffsll.c += -fno-builtin
CFLAGS-bench-sqrt.c += -fno-builtin
CFLAGS-bench-fmin.c += -fno-builtin
CFLAGS-bench-fminf.c += -fno-builtin
CFLAGS-bench-fma.c += -fno-builtin
CFLAGS-bench-fmaf.c += -fno-builtin
CFLAGS-bench-fmax.c += -fno-builtin
CFLAGS-bench-fmaxf.c += -fno-builtin
CFLAGS-bench-trunc.c += -fno-builtin
CFLAGS-bench-truncf.c += -fno-builtin
CFLAGS-bench-fmod.c += -fno-builtin
CFLAGS-bench-fmodf.c += -fno-builtin
CFLAGS-bench-frexp.c += -fno-builtin
CFLAGS-bench-frexpf.c += -fno-builtin
CFLAGS-bench-frexpl.c += -fno-builtin
CFLAGS-bench-remainder.c += -fno-builtin
CFLAGS-bench-remainderf.c += -fno-builtin
CFLAGS-bench-roundeven.c += -fno-builtin
CFLAGS-bench-roundevenf.c += -fno-builtin
CFLAGS-bench-isnan.c += $(config-cflags-signaling-nans)
CFLAGS-bench-isinf.c += $(config-cflags-signaling-nans)
CFLAGS-bench-isfinite.c += $(config-cflags-signaling-nans)

ifeq (${BENCHSET},)
bench-malloc := \
  calloc-simple \
  calloc-tcache \
  calloc-thread \
  malloc-simple \
  malloc-tcache \
  malloc-thread \
  # bench-malloc
else
bench-malloc := $(filter malloc-%,${BENCHSET})
bench-malloc += $(filter calloc-%,${BENCHSET})
endif

ifeq (${STATIC-BENCHTESTS},yes)
+link-benchtests = $(+link-static-tests)
link-libc-benchtests = $(link-libc-static)
libm-benchtests = $(common-objpfx)math/libm.a
thread-library-benchtests = $(static-thread-library)
else
link-libc-benchtests = $(link-libc)
+link-benchtests = $(+link-tests)
thread-library-benchtests = $(shared-thread-library)
libm-benchtests = $(libm)
endif

$(addprefix $(objpfx)bench-,$(bench-math)): $(libm-benchtests)
$(addprefix $(objpfx)bench-,$(math-benchset)): $(libm-benchtests)
$(addprefix $(objpfx)bench-,$(bench-pthread)): $(thread-library-benchtests)
$(addprefix $(objpfx)bench-,$(bench-malloc)): $(thread-library-benchtests)
$(addprefix $(objpfx)bench-,pthread-locks): $(libm-benchtests)
$(addprefix $(objpfx)bench-,pthread-mutex-locks): $(libm-benchtests)
$(addprefix $(objpfx)bench-,malloc-thread): $(libm-benchtests)
$(addprefix $(objpfx)bench-,calloc-thread): $(libm-benchtests)



# Rules to build and execute the benchmarks.  Do not put any benchmark
# parameters beyond this point.

# We don't want the benchmark programs to run in parallel since that could
# affect their performance.
.NOTPARALLEL:

bench-extra-objs = json-lib.o

extra-objs += $(bench-extra-objs)
others-extras = $(bench-extra-objs)

# The default duration: 1 seconds.
ifndef BENCH_DURATION
BENCH_DURATION := 1
endif

CPPFLAGS-nonlib += -DDURATION=$(BENCH_DURATION) -D_ISOMAC

# Use clock_gettime to measure performance of functions.  The default is
# to use the architecture-specific high precision timing instructions.
ifdef USE_CLOCK_GETTIME
CPPFLAGS-nonlib += -DUSE_CLOCK_GETTIME
else
# On x86 processors, use RDTSCP, instead of RDTSC, to measure performance
# of functions.  All x86 processors since 2010 support RDTSCP instruction.
ifdef USE_RDTSCP
CPPFLAGS-nonlib += -DUSE_RDTSCP
endif
endif

DETAILED_OPT :=

ifdef DETAILED
DETAILED_OPT := -d
endif

bench-deps := bench-skeleton.c bench-timing.h Makefile

run-bench = $(test-wrapper-env) \
	    $(run-program-env) \
	    $($*-ENV) $(test-via-rtld-prefix) $${run}

timing-type := $(objpfx)bench-timing-type
extra-objs += bench-timing-type.o

include ../Rules

bench-math += $(bench-libmvec)

ifeq (${BENCHSET},)
bench := \
  $(bench-math) \
  $(bench-pthread) \
  $(bench-resolv) \
  $(bench-string) \
  # bench
else
bench := $(foreach B,$(filter bench-%,${BENCHSET}), ${${B}})
endif

# NB: Use "=" instead of ":=" since sysdeps Makefiles may add more
# benches.
binaries-bench = $(addprefix $(objpfx)bench-,$(bench))
extra-objs += $(addsuffix .o,$(addprefix bench-,$(bench)))
binaries-benchset = $(addprefix $(objpfx)bench-,$(benchset))
extra-objs += $(addsuffix .o,$(addprefix bench-,$(benchset)))
binaries-bench-malloc := $(addprefix $(objpfx)bench-,$(bench-malloc))
extra-objs += $(addsuffix .o,$(addprefix bench-,$(bench-malloc)))

# This makes sure CPPFLAGS-nonlib and CFLAGS-nonlib are passed
# for all these modules.
cpp-srcs-left := \
  $(binaries-bench-malloc:=.c) \
  $(binaries-bench:=.c) \
  $(binaries-benchset:=.c) \
  $(timing-type:=.c) \
  # cpp-srcs-left
lib := nonlib
include $(patsubst %,$(..)libof-iterator.mk,$(cpp-srcs-left))

bench-clean:
	rm -f $(binaries-bench) $(addsuffix .o,$(binaries-bench))
	rm -f $(binaries-benchset) $(addsuffix .o,$(binaries-benchset))
	rm -f $(binaries-bench-malloc) $(addsuffix .o,$(binaries-bench-malloc))
	rm -f $(timing-type) $(addsuffix .o,$(timing-type))
	rm -f $(addprefix $(objpfx),$(bench-extra-objs))

# Validate the passed in BENCHSET
ifneq ($(strip ${BENCHSET}),)
VALIDBENCHSETNAMES := \
  bench-math \
  bench-pthread \
  bench-resolv \
  bench-string \
  calloc-simple \
  calloc-tcache \
  calloc-thread \
  hash-benchset \
  malloc-simple \
  malloc-tcache \
  malloc-thread \
  math-benchset \
  stdio-benchset \
  stdio-common-benchset \
  stdlib-benchset \
  string-benchset \
  wcsmbs-benchset \
  # VALIDBENCHSETNAMES

INVALIDBENCHSETNAMES := $(filter-out ${VALIDBENCHSETNAMES},${BENCHSET})
ifneq (${INVALIDBENCHSETNAMES},)
$(info The following values in BENCHSET are invalid: ${INVALIDBENCHSETNAMES})
$(info The valid ones are: ${VALIDBENCHSETNAMES})
$(error Invalid BENCHSET value)
endif
endif

bench: bench-build bench-set bench-func bench-malloc

# Target to only build the benchmark without running it.  We generate locales
# only if we're building natively.
ifeq (no,$(cross-compiling))
bench-build: $(gen-locales) $(timing-type) $(binaries-bench) \
	$(binaries-benchset) $(binaries-bench-malloc)
else
bench-build: $(timing-type) $(binaries-bench) $(binaries-benchset) \
	$(binaries-bench-malloc)
endif

bench-set: $(binaries-benchset)
	for run in $^; do \
	  echo "Running $${run}"; \
	  $(run-bench) > $${run}.out; \
	done

bench-malloc: $(binaries-bench-malloc)
	for run in $^; do \
	  echo "$${run}"; \
	  if basename $${run} | grep -q "bench-[cm]alloc-thread"; then \
		for thr in 1 8 16 32; do \
			echo "Running $${run} $${thr}"; \
			$(run-bench) $${thr} > $${run}-$${thr}.out; \
		done;\
	  elif basename $${run} | grep -q "bench-[cm]alloc-tcache"; then \
		for thr in 64 512 1024; do \
			echo "Running $${run} $${thr}"; \
			$(run-bench) $${thr} > $${run}-$${thr}.out; \
		done;\
	  else \
		for thr in 8 16 32 64 128 256 512 1024 2048 4096; do \
		  echo "Running $${run} $${thr}"; \
		  $(run-bench) $${thr} > $${run}-$${thr}.out; \
		done;\
	  fi;\
	done

=== csu/Makefile ===
# Makefile for csu code for GNU C library.
# Copyright (C) 1995-2026 Free Software Foundation, Inc.
# This file is part of the GNU C Library.

# The GNU C Library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.

# The GNU C Library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.

# You should have received a copy of the GNU Lesser General Public
# License along with the GNU C Library; if not, see
# <https://www.gnu.org/licenses/>.

# This directory contains the C startup code (that which calls main).  This
# consists of the startfile, built from start.c and installed as crt0.o
# (traditionally) or crt1.o (for ELF).	In ELF we also install crti.o and
# crtn.o, special "initializer" and "finalizer" files used in the link
# to make the .init and .fini sections work right.

subdir := csu

include ../Makeconfig

routines = \
  $(libc-init) \
  check_fds \
  dso_handle \
  init-first \
  libc-start \
  libc-tls \
  sysdep \
  version \
  # routines
aux	 = errno
elide-routines.os = libc-tls
csu-dummies = $(filter-out $(start-installed-name),crt1.o Mcrt1.o)
extra-objs = \
  $(csu-dummies) \
  $(start-installed-name) \
  $(start-name-2.0) \
  S$(start-installed-name) \
  g$(start-installed-name) \
  start.o \
  # extra-objs
omit-deps = $(patsubst %.o,%,$(start-installed-name) g$(start-installed-name) \
			     b$(start-installed-name) $(csu-dummies) \
			     S$(start-installed-name) \
			     r$(start-installed-name) \
			     gr$(start-installed-name))
install-lib = \
  $(csu-dummies) \
  $(start-installed-name) \
  g$(start-installed-name) \
  # install-lib

# No tests are allowed in the csu/ subdirectory because the startup
# code is compiled with special flags.
tests =

# static-reloc.os is a dummy object not actually used for anything.  It is
# linked into crt1.o nevertheless, which in turn is statically linked into
# applications, so that build flags matter.
# See <https://sourceware.org/ml/libc-alpha/2018-07/msg00101.html>.
#
# The function is called prior the thread pointer setup, and if stack
# protector is enabled the compiler might still generate the stack check
# (which requires the thread pointer correctly set).
extra-no-ssp = static-reloc

# libc-start.os is safe to be built with stack protector since
# __libc_start_main is called after stack canary setup is done.
ssp-safe.os = libc-start

CFLAGS-.o += $(call elide-stack-protector,.o,$(routines) $(extra-no-ssp))
CFLAGS-.op += $(call elide-stack-protector,.op,$(routines) $(extra-no-ssp))
CFLAGS-.oS += $(call elide-stack-protector,.oS,$(routines) $(extra-no-ssp))
CFLAGS-.os += $(call elide-stack-protector,.os,$(filter-out \
						 $(ssp-safe.os), \
						 $(routines) $(extra-no-ssp)))

ifeq (yes,$(build-shared))
extra-objs += \
  S$(start-installed-name) \
  gmon-start.os \
  # extra-objs
ifneq ($(start-installed-name),$(static-start-installed-name))
extra-objs += gmon-start.o
endif
install-lib += S$(start-installed-name)
generated += start.os
else
extra-objs += gmon-start.o
endif

ifeq (yes,$(enable-static-pie))
extra-objs += \
  gr$(start-installed-name) \
  r$(start-installed-name) \
  # extra-objs
install-lib += \
  gr$(start-installed-name) \
  r$(start-installed-name) \
  # install-lib
endif

ifneq ($(start-installed-name),$(static-start-installed-name))
extra-objs += \
  $(static-start-installed-name) \
  g$(static-start-installed-name) \
  # extra-objs
omit-deps += $(patsubst %.o,%,$(static-start-installed-name) \
			     g$(static-start-installed-name))
install-lib += \
  $(static-start-installed-name) \
  g$(static-start-installed-name) \
  # install-lib
ifeq (yes,$(enable-static-pie))
extra-objs += \
  gr$(static-start-installed-name) \
  r$(static-start-installed-name) \
  # extra-objs
omit-deps += $(patsubst %.o,%,r$(static-start-installed-name) \
			     gr$(static-start-installed-name))
install-lib += \
  gr$(static-start-installed-name) \
  r$(static-start-installed-name) \
  # install-lib
endif
endif

before-compile += $(objpfx)abi-tag.h
generated += abi-tag.h

# Put it here to generate it earlier.
gen-as-const-headers += rtld-sizes.sym sem_t-align.sym

# These are the special initializer/finalizer files.  They are always the
# first and last file in the link.  crti.o ... crtn.o define the global
# "functions" _init and _fini to run the .init and .fini sections.
crtstuff = \
  crti \
  crtn \
  # crtstuff

install-lib += $(crtstuff:=.o)
extra-objs += $(crtstuff:=.o)

ifneq ($(multidir),.)
multilib-extra-objs = $(addprefix $(multidir)/, $(install-lib))
extra-objs += $(multilib-extra-objs)
endif

extra-objs += \
  abi-note.o \
  init.o \
  static-reloc.o \
  # extra-objs
ifeq (yes,$(build-shared))
extra-objs += static-reloc.os
endif
asm-CPPFLAGS += -I$(objpfx).

# Enable unwinding so backtrace unwinds to __libc_start_main
CFLAGS-libc-start.c += -funwind-tables

include ../Rules

# Make these in the lib pass so they're available in time to link things with.
subdir_lib: $(extra-objs:%=$(objpfx)%)

define link-relocatable
$(CC) -nostdlib -nostartfiles -r -o $@ $^
endef

ifndef start-installed-name-rule
# We link the ELF startfile along with a SHT_NOTE section indicating
# the kernel ABI the binaries linked with this library will require.
$(objpfx)$(start-installed-name): $(objpfx)start.o $(objpfx)abi-note.o \
				  $(objpfx)init.o $(objpfx)static-reloc.o
	$(link-relocatable)
$(objpfx)$(start-name-2.0): $(objpfx)start.o $(objpfx)abi-note.o \
			    $(objpfx)static-reloc.o
	$(link-relocatable)
$(objpfx)r$(start-installed-name): $(objpfx)start.o $(objpfx)abi-note.o \
				  $(objpfx)init.o
	$(link-relocatable)
$(objpfx)S$(start-installed-name): $(objpfx)start.os $(objpfx)abi-note.o \
				  $(objpfx)init.o
	$(link-relocatable)
endif

# The profiling startfile is made by linking together the normal
# startfile with gmon-start.o, which defines a constructor function
# to turn on profiling code at startup.
ifeq (yes,$(build-shared))
$(objpfx)g$(start-installed-name): \
  $(objpfx)g%: $(objpfx)S% $(objpfx)gmon-start.os $(objpfx)static-reloc.os
	$(link-relocatable)
$(objpfx)gr$(start-installed-name): \
  $(objpfx)gr%: $(objpfx)r% $(objpfx)gmon-start.o
	$(link-relocatable)
ifneq ($(start-installed-name),$(static-start-installed-name))
$(objpfx)g$(static-start-installed-name): \
  $(objpfx)g%: $(objpfx)% $(objpfx)gmon-start.o
	$(link-relocatable)
$(objpfx)gr$(static-start-installed-name): \
  $(objpfx)gr%: $(objpfx)r% $(objpfx)gmon-start.o
	$(link-relocatable)
endif
else
$(addprefix $(objpfx),$(sort g$(start-installed-name) \
			     g$(static-start-installed-name))): \
  $(objpfx)g%: $(objpfx)% $(objpfx)gmon-start.o
	$(link-relocatable)
endif

# These extra files are sometimes expected by system standard linking
# procedures, but we have nothing for them to do.  So compile empty files.
$(addprefix $(objpfx),$(filter-out $(start-installed-name), $(csu-dummies))):\
  $(before-compile)
	$(COMPILE.c) -o $@ -x c /dev/null

# These headers are used by the startup code.
$(objpfx)abi-tag.h: $(..)abi-tags
	$(make-target-directory)
	rm -f $@.new
	sed -e 's/#.*$$//' -e '/^[	]*$$/d' $< | \
	while read conf tagos tagver; do \
	  test `expr '$(config-machine)-$(config-vendor)-$(config-os)' \
		     : "$$conf"` != 0 || continue; \
	  ( echo "$$tagos" | \
	    sed -e 's/[^0-9xXa-fA-F 	]//' \
		-e 's/^/#define __ABI_TAG_OS /'; \
	    echo "#ifndef __ABI_TAG_VERSION"; \
	    echo "$$tagver" | \
	    sed -e 's/[^0-9xXa-fA-F]/ /g' -e 's/ *$$//' \
	      -e 's/ /,/g' -e 's/^/# define __ABI_TAG_VERSION /'; \
	    echo "#endif" ) > $@.new; \
	done
	if test -r $@.new; then mv -f $@.new $@; \
	else echo >&2 'This configuration not matched in $<'; exit 1; fi

ifneq ($(multidir),.)
$(addprefix $(objpfx)$(multidir)/, $(install-lib)): $(addprefix $(objpfx), $(install-lib))
	$(make-link-multidir)
endif

=== gmon/Makefile ===
# Copyright (C) 1995-2026 Free Software Foundation, Inc.
# Copyright The GNU Toolchain Authors.
# This file is part of the GNU C Library.

# The GNU C Library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.

# The GNU C Library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.

# You should have received a copy of the GNU Lesser General Public
# License along with the GNU C Library; if not, see
# <https://www.gnu.org/licenses/>.

#
#	Sub-makefile for gmon portion of the library.
#
subdir	:= gmon

include ../Makeconfig

headers := \
  sys/gmon.h \
  sys/gmon_out.h \
  sys/profil.h \
  # headers
routines := \
  gmon \
  mcount \
  prof-freq \
  profil \
  sprofil \
  # routines

tests = \
  tst-gmon \
  tst-mcleanup \
  tst-mcount-overflow \
  tst-sprofil \
  # tests
# clang does not support -profile to instruct linker to use lc_p
ifeq ($(build-profile)$(have-test-clang),yesno)
tests += tst-profile-static
tests-static += tst-profile-static

LDFLAGS-tst-profile-static = -profile
endif

tests += tst-gmon-static
tests-static += tst-gmon-static

ifeq (yesyes,$(have-fpie)$(build-shared))
tests += tst-gmon-pie
tests-pie += tst-gmon-pie
ifeq (yes,$(enable-static-pie))
tests += tst-gmon-static-pie
tests-static += tst-gmon-static-pie
endif
endif

# The mcount code won't work without a frame pointer nor when memcpy or
# memset are called.
CFLAGS-mcount.c := -fno-omit-frame-pointer
ifeq (yes,$(config-cflags-cc-loop-to-function))
CFLAGS-mcount.c += -fno-tree-loop-distribute-patterns
endif

CFLAGS-tst-gmon.c := -fno-omit-frame-pointer -pg
tst-gmon-no-pie = yes
CRT-tst-gmon := $(csu-objpfx)g$(start-installed-name)
tst-gmon-ENV := GMON_OUT_PREFIX=$(objpfx)tst-gmon.data
ifeq ($(run-built-tests),yes)
tests-special += $(objpfx)tst-gmon-gprof.out
endif

CFLAGS-tst-mcount-overflow.c := -fno-omit-frame-pointer -pg
tst-mcount-overflow-no-pie = yes
CRT-tst-mcount-overflow := $(csu-objpfx)g$(start-installed-name)
# Intentionally use invalid config where maxarcs<minarcs to check warning is printed
tst-mcount-overflow-ENV := GMON_OUT_PREFIX=$(objpfx)tst-mcount-overflow.data \
                           GLIBC_TUNABLES=glibc.gmon.minarcs=51:glibc.gmon.maxarcs=50
# Send stderr into output file because we make sure expected messages are printed
tst-mcount-overflow-ARGS := 2>&1 1>/dev/null | cat
ifeq ($(run-built-tests),yes)
tests-special += $(objpfx)tst-mcount-overflow-check.out
endif

CFLAGS-tst-mcleanup.c := -fno-omit-frame-pointer -pg
tst-mcleanup-no-pie = yes
CRT-tst-mcleanup := $(csu-objpfx)g$(start-installed-name)
tst-mcleanup-ENV := GMON_OUT_PREFIX=$(objpfx)tst-mcleanup.data
ifeq ($(run-built-tests),yes)
tests-special += $(objpfx)tst-mcleanup.out
endif

CFLAGS-tst-gmon-static.c := $(PIE-ccflag) -fno-omit-frame-pointer -pg
CRT-tst-gmon-static := $(csu-objpfx)g$(static-start-installed-name)
tst-gmon-static-no-pie = yes
tst-gmon-static-ENV := GMON_OUT_PREFIX=$(objpfx)tst-gmon-static.data
ifeq ($(run-built-tests),yes)
tests-special += $(objpfx)tst-gmon-static-gprof.out
endif

CFLAGS-tst-gmon-pie.c := $(PIE-ccflag) -fno-omit-frame-pointer -pg
CRT-tst-gmon-pie := $(csu-objpfx)g$(start-installed-name)
tst-gmon-pie-ENV := GMON_OUT_PREFIX=$(objpfx)tst-gmon-pie.data
ifeq ($(run-built-tests),yes)
tests-special += $(objpfx)tst-gmon-pie-gprof.out
endif

ifeq (yes,$(enable-static-pie))
CFLAGS-tst-gmon-static-pie.c := $(PIE-ccflag) -fno-omit-frame-pointer -pg
CRT-tst-gmon-static-pie := $(csu-objpfx)gr$(static-start-installed-name)
tst-gmon-static-pie-ENV := GMON_OUT_PREFIX=$(objpfx)tst-gmon-static-pie.data
ifeq ($(run-built-tests),yes)
tests-special += $(objpfx)tst-gmon-static-pie-gprof.out
endif
endif


include ../Rules

# We cannot compile mcount.c with -pg because that would
# create recursive calls.  Just copy the normal static object.
# On systems where `profil' is not a system call, the same
# problem exists for the internal functions in profil.c.

noprof := mcount $(sysdep_noprof)
ifeq (,$(filter profil,$(unix-syscalls)))
noprof += profil sprofil
endif

$(noprof:%=$(objpfx)%.op): %.op: %.o
	rm -f $@
	ln $< $@

# GMON_OUTPUT_PREFIX only sets the output prefix.  The actual file
# name contains the PID as well.
$(objpfx)tst-gmon.out: clean-tst-gmon-data
clean-tst-gmon-data:
	rm -f $(objpfx)tst-gmon.data.*

$(objpfx)tst-mcount-overflow.o: clean-tst-mcount-overflow-data
clean-tst-mcount-overflow-data:
	rm -f $(objpfx)tst-mcount-overflow.data.*

$(objpfx)tst-mcount-overflow-check.out: tst-mcount-overflow-check.sh $(objpfx)tst-mcount-overflow.out
	$(SHELL) $< $(objpfx)tst-mcount-overflow > $@; \
	$(evaluate-test)

$(objpfx)tst-mcleanup.out: clean-tst-mcleanup-data
clean-tst-mcleanup-data:
	rm -f $(objpfx)tst-mcleanup.data.*

$(objpfx)tst-gmon-gprof.out: tst-gmon-gprof.sh $(objpfx)tst-gmon.out
	$(SHELL) $< $(GPROF) $(objpfx)tst-gmon $(objpfx)tst-gmon.data.* > $@; \
	$(evaluate-test)

$(objpfx)tst-gmon-static.out: clean-tst-gmon-static-data
clean-tst-gmon-static-data:
	rm -f $(objpfx)tst-gmon-static.data.*

$(objpfx)tst-gmon-static-gprof.out: tst-gmon-static-gprof.sh \
				    $(objpfx)tst-gmon-static.out
	$(SHELL) $< $(GPROF) $(objpfx)tst-gmon-static \
		$(objpfx)tst-gmon-static.data.* > $@; \
	$(evaluate-test)

$(objpfx)tst-gmon-pie.out: clean-tst-gmon-pie-data
clean-tst-gmon-pie-data:
	rm -f $(objpfx)tst-gmon-pie.data.*

$(objpfx)tst-gmon-pie-gprof.out: tst-gmon-gprof.sh $(objpfx)tst-gmon-pie.out
	$(SHELL) $< $(GPROF) $(objpfx)tst-gmon-pie $(objpfx)tst-gmon-pie.data.* > $@; \
	$(evaluate-test)

$(objpfx)tst-gmon-static-pie.out: clean-tst-gmon-static-pie-data
clean-tst-gmon-static-pie-data:
	rm -f $(objpfx)tst-gmon-static-pie.data.*

$(objpfx)tst-gmon-static-pie-gprof.out: tst-gmon-static-gprof.sh \
					$(objpfx)tst-gmon-static-pie.out
	$(SHELL) $< $(GPROF) $(objpfx)tst-gmon-static-pie \
		$(objpfx)tst-gmon-static-pie.data.* > $@; \
	$(evaluate-test)

=== htl/Makefile ===
#
#   Copyright (C) 1994-2026 Free Software Foundation, Inc.
#
#   The GNU C Library is free software; you can redistribute it and/or
#   modify it under the terms of the GNU Lesser General Public
#   License as published by the Free Software Foundation; either
#   version 2.1 of the License, or (at your option) any later version.

#   The GNU C Library is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#   Lesser General Public License for more details.

#   You should have received a copy of the GNU Lesser General Public
#   License along with the GNU C Library; if not, see
#   <https://www.gnu.org/licenses/>.

subdir := htl

srcdir = .

MICROKERNEL := mach
SYSDEPS :=

LCLHDRS :=

libpthread-routines :=

headers := \
  bits/cancelation.h \
  bits/pthread-np.h \
  bits/pthread.h \
  bits/pthreadtypes-arch.h \
  bits/pthreadtypes.h \
  bits/semaphore.h \
  bits/thread-shared-types.h \
  bits/types/__pthread_key.h \
  bits/types/__pthread_spinlock_t.h \
  bits/types/__pthread_t.h \
  bits/types/__thrd_t.h \
  bits/types/struct___pthread_attr.h \
  bits/types/struct___pthread_barrier.h \
  bits/types/struct___pthread_barrierattr.h \
  bits/types/struct___pthread_cond.h \
  bits/types/struct___pthread_condattr.h \
  bits/types/struct___pthread_mutex.h \
  bits/types/struct___pthread_mutexattr.h \
  bits/types/struct___pthread_once.h \
  bits/types/struct___pthread_rwlock.h \
  bits/types/struct___pthread_rwlockattr.h \
  pthread.h \
  semaphore.h \
  # headers

distribute :=

routines := \
  alloca_cutoff \
  cancellation \
  htlfreeres \
  pt-alloc \
  pt-attr \
  pt-attr-destroy \
  pt-attr-getdetachstate \
  pt-attr-getguardsize \
  pt-attr-getinheritsched \
  pt-attr-getschedparam \
  pt-attr-getschedpolicy \
  pt-attr-getscope \
  pt-attr-getstack \
  pt-attr-getstackaddr \
  pt-attr-getstacksize \
  pt-attr-init \
  pt-attr-setdetachstate \
  pt-attr-setguardsize \
  pt-attr-setinheritsched \
  pt-attr-setschedparam \
  pt-attr-setschedpolicy \
  pt-attr-setscope \
  pt-attr-setstack \
  pt-attr-setstackaddr \
  pt-attr-setstacksize \
  pt-barrier \
  pt-barrier-destroy \
  pt-barrier-init \
  pt-barrier-wait \
  pt-barrierattr-destroy \
  pt-barrierattr-getpshared \
  pt-barrierattr-init \
  pt-barrierattr-setpshared \
  pt-block \
  pt-block-intr \
  pt-cancel \
  pt-cleanup \
  pt-cond \
  pt-cond-brdcast \
  pt-cond-destroy \
  pt-cond-init \
  pt-cond-signal \
  pt-cond-timedwait \
  pt-cond-wait \
  pt-condattr-destroy \
  pt-condattr-getclock \
  pt-condattr-getpshared \
  pt-condattr-init \
  pt-condattr-setclock \
  pt-condattr-setpshared \
  pt-create \
  pt-dealloc \
  pt-destroy-specific \
  pt-detach \
  pt-docancel \
  pt-exit \
  pt-getattr \
  pt-getconcurrency \
  pt-getcpuclockid \
  pt-getname-np \
  pt-getschedparam \
  pt-getspecific \
  pt-hurd-cond-timedwait \
  pt-hurd-cond-wait \
  pt-init-specific \
  pt-join \
  pt-key-create \
  pt-key-delete \
  pt-kill \
  pt-machdep \
  pt-mutex-checklocked \
  pt-mutex-consistent \
  pt-mutex-destroy \
  pt-mutex-getprioceiling \
  pt-mutex-init \
  pt-mutex-lock \
  pt-mutex-setprioceiling \
  pt-mutex-timedlock \
  pt-mutex-transfer-np \
  pt-mutex-trylock \
  pt-mutex-unlock \
  pt-mutexattr-destroy \
  pt-mutexattr-getprioceiling \
  pt-mutexattr-getprotocol \
  pt-mutexattr-getpshared \
  pt-mutexattr-getrobust \
  pt-mutexattr-gettype \
  pt-mutexattr-init \
  pt-mutexattr-setprioceiling \
  pt-mutexattr-setprotocol \
  pt-mutexattr-setpshared \
  pt-mutexattr-setrobust \
  pt-mutexattr-settype \
  pt-nthreads \
  pt-once \
  pt-pthread_self \
  pt-rwlock-attr \
  pt-rwlock-destroy \
  pt-rwlock-init \
  pt-rwlock-rdlock \
  pt-rwlock-timedrdlock \
  pt-rwlock-timedwrlock \
  pt-rwlock-tryrdlock \
  pt-rwlock-trywrlock \
  pt-rwlock-unlock \
  pt-rwlock-wrlock \
  pt-rwlockattr-destroy \
  pt-rwlockattr-getpshared \
  pt-rwlockattr-init \
  pt-rwlockattr-setpshared \
  pt-self pt-equal \
  pt-setcancelstate \
  pt-setcanceltype \
  pt-setconcurrency \
  pt-setname-np \
  pt-setschedparam \
  pt-setschedprio \
  pt-setspecific \
  pt-setup \
  pt-sigmask \
  pt-sigstate \
  pt-sigstate-destroy \
  pt-sigstate-init \
  pt-spin-inlines \
  pt-stack-alloc \
  pt-startup \
  pt-sysdep \
  pt-testcancel \
  pt-thread-alloc \
  pt-thread-start \
  pt-thread-terminate \
  pt-timedblock \
  pt-timedblock-intr \
  pt-wakeup \
  pt-yield \
  sem-destroy \
  sem-getvalue \
  sem-init \
  sem-post \
  sem-timedwait \
  sem-trywait \
  sem-wait \
  sem-waitfast \
  sem_close \
  sem_open \
  sem_routines \
  sem_unlink \
  # routines

extra-libs := libpthread
extra-libs-others := $(extra-libs)
install-lib := libpthread.so
install-lib-ldscripts := libpthread_syms.a

include ../Makeconfig

all: # Make this the default target; it will be defined in Rules.

subdir_install: $(inst_libdir)/libpthread2.a $(inst_libdir)/libpthread_syms.a

# XXX: If $(inst_libdir)/libpthread2.a is installed and
# $(inst_libdir)/libpthread is not, we can have some issues.
.PHONY: $(inst_libdir)/libpthread.a $(inst_libdir)/libpthread_pic.a

# XXX: These rules are a hack.  But it is better than messing with
# ../Makeconf at the moment.  Note that the linker scripts
# $(srcdir)/libpthread.a and $(srcdir)/libpthread_pic.a get overwritten
# when building in $(srcdir) and not a separate build directory.
$(inst_libdir)/libpthread2.a: $(inst_libdir)/libpthread.a
	mv $< $@
	$(INSTALL_DATA) $(srcdir)/libpthread.a $<

$(inst_libdir)/libpthread2_pic.a: $(inst_libdir)/libpthread_pic.a
	mv $< $@
	$(INSTALL_DATA) $(srcdir)/libpthread_pic.a $<

$(inst_libdir)/libpthread_syms.a: $(srcdir)/libpthread_syms.a $(+force)
	$(do-install)

libc-link.so = $(common-objpfx)libc.so

extra-B-pthread.so = -B$(common-objpfx)htl/
LDFLAGS-pthread.so = -Wl,--enable-new-dtags,-z,nodelete,-z,initfirst

include ../Rules

# Make sure we link with the thread library.
ifeq ($(build-shared),yes)
$(addprefix $(objpfx), \
  $(filter-out $(tests-static) $(xtests-static) $(tests-reverse) \
    $(tests-nolibpthread), \
    $(tests) $(tests-internal) $(xtests) $(test-srcs) $(tests-container))): \
	$(objpfx)libpthread.so
# $(objpfx)../libc.so is used instead of $(common-objpfx)libc.so,
# since otherwise libpthread.so comes before libc.so when linking.
$(addprefix $(objpfx), $(tests-reverse)): \
  $(objpfx)../libc.so $(objpfx)libpthread.so
$(objpfx)../libc.so: $(common-objpfx)libc.so ;
$(addprefix $(objpfx),$(tests-static) $(xtests-static)): $(srcdir)/libpthread_syms.a $(objpfx)libpthread.a
else
$(addprefix $(objpfx),$(tests) $(test-srcs)): $(srcdir)/libpthread_syms.a $(objpfx)libpthread.a
endif

=== math/Makefile ===
# Copyright (C) 1996-2026 Free Software Foundation, Inc.
# This file is part of the GNU C Library.

# The GNU C Library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.

# The GNU C Library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.

# You should have received a copy of the GNU Lesser General Public
# License along with the GNU C Library; if not, see
# <https://www.gnu.org/licenses/>.

# Makefile for the math library.

subdir		:= math

include ../Makeconfig

# Installed header files.
headers := \
  bits/cmathcalls.h \
  bits/fenv.h \
  bits/floatn-common.h \
  bits/floatn.h \
  bits/flt-eval-method.h \
  bits/fp-fast.h \
  bits/fp-logb.h \
  bits/iscanonical.h \
  bits/libm-simd-decl-stubs.h \
  bits/long-double.h \
  bits/math-vector.h \
  bits/mathcalls-helper-functions.h \
  bits/mathcalls-macros.h \
  bits/mathcalls-narrow.h \
  bits/mathcalls.h \
  bits/mathdef.h \
  complex.h \
  fenv.h \
  finclude/math-vector-fortran.h \
  fpu_control.h \
  math.h \
  tgmath.h \
  # headers

# FPU support code.
aux := \
  fpu_control \
  setfpucw \
  # aux

# Build the -lm library.

extra-libs	:= libm
extra-libs-others = $(extra-libs)

libm-support = \
  fclrexcpt \
  fedisblxcpt \
  feenablxcpt \
  fegetenv \
  fegetexcept \
  fegetmode \
  fegetround \
  feholdexcpt \
  fesetenv \
  fesetexcept \
  fesetmode\
  fesetround \
  fetestexceptflag \
  feupdateenv \
  fgetexcptflg \
  fraiseexcpt \
  fsetexcptflg \
  ftestexcept \
  s_lib_version \
  s_matherr \
  s_signgam \
  # libm-support

# Wrappers for these functions generated per type using a file named
# <func>_template.c and the appropriate math-type-macros-<TYPE>.h.
gen-libm-calls = \
  cabsF \
  cargF \
  cimagF \
  conjF \
  crealF \
  e_exp2F \
  e_scalbF \
  k_casinhF \
  k_casinhF \
  s_acospiF \
  s_asinpiF \
  s_atan2piF \
  s_atanpiF \
  s_cacosF  \
  s_cacoshF \
  s_canonicalizeF \
  s_casinF \
  s_casinhF \
  s_catanF \
  s_catanhF \
  s_ccosF \
  s_ccoshF \
  s_cexpF \
  s_clog10F \
  s_clogF \
  s_compoundnF \
  s_cospiF \
  s_cpowF \
  s_cprojF \
  s_csinF \
  s_csinhF \
  s_csinhF \
  s_csqrtF \
  s_ctanF \
  s_ctanhF \
  s_exp10m1F \
  s_exp2m1F \
  s_fdimF \
  s_fmaxF \
  s_fmaximumF \
  s_fmaximum_magF \
  s_fmaximum_mag_numF \
  s_fmaximum_numF \
  s_fmaxmagF \
  s_fminF \
  s_fminimumF \
  s_fminimum_magF \
  s_fminimum_mag_numF \
  s_fminimum_numF \
  s_fminmagF \
  s_iseqsigF \
  s_log10p1F \
  s_log2p1F \
  s_nanF \
  s_nextdownF \
  s_pownF \
  s_powrF \
  s_rootnF \
  s_rsqrtF \
  s_significandF \
  s_sinpiF \
  s_tanpiF \
  w_acosF \
  w_acoshF \
  w_asinF \
  w_atan2F \
  w_atanhF \
  w_coshF \
  w_exp10F \
  w_exp2F \
  w_expF \
  w_fmodF \
  w_hypotF \
  w_ilogbF \
  w_j0F \
  w_j1F \
  w_jnF \
  w_lgammaF \
  w_lgammaF_r \
  w_llogbF \
  w_log10F \
  w_log1pF \
  w_log2F \
  w_logF  \
  w_powF \
  w_remainderF \
  w_scalbF \
  w_scalblnF \
  w_sinhF \
  w_sqrtF \
  w_tgammaF \
  # gen-libm-calls

libm-calls = \
  $(calls:s_%=m_%) \
  $(gen-libm-calls) \
  e_acosF \
  e_acoshF \
  e_asinF \
  e_atan2F \
  e_atanhF \
  e_coshF \
  e_exp10F \
  e_expF \
  e_fmodF \
  e_gammaF_r \
  e_hypotF \
  e_ilogbF \
  e_j0F \
  e_j1F \
  e_jnF \
  e_lgammaF_r \
  e_log10F \
  e_log2F \
  e_logF \
  e_powF \
  e_remainderF \
  e_sinhF \
  e_sqrtF \
  k_tanF \
  s_asinhF \
  s_atanF \
  s_cbrtF \
  s_ceilF \
  s_compat_fromfpF \
  s_compat_fromfpxF \
  s_compat_ufromfpF \
  s_compat_ufromfpxF \
  s_cosF \
  s_erfF \
  s_erfcF \
  s_expm1F \
  s_fabsF \
  s_floorF \
  s_fmaF \
  s_fpclassifyF \
  s_fromfpF \
  s_fromfpxF \
  s_getpayloadF \
  s_issignalingF \
  s_llrintF \
  s_llroundF \
  s_log1pF \
  s_logbF \
  s_lrintF \
  s_lroundF \
  s_nearbyintF \
  s_nextafterF \
  s_nexttowardF \
  s_nextupF \
  s_remquoF \
  s_rintF \
  s_roundF \
  s_roundevenF \
  s_scalblnF \
  s_setpayloadF \
  s_setpayloadsigF \
  s_sinF \
  s_sincosF \
  s_tanF \
  s_tanhF \
  s_totalorderF \
  s_totalordermagF \
  s_truncF \
  s_ufromfpF \
  s_ufromfpxF \
  x2y2m1F \
  # libm-calls

libm-compat-calls = \
  k_standardF \
  w_acosF_compat \
  w_acoshF_compat \
  w_asinF_compat \
  w_atan2F_compat \
  w_atanhF_compat \
  w_coshF_compat \
  w_exp10F_compat \
  w_exp2F_compat \
  w_expF_compat	\
  w_fmodF_compat \
  w_hypotF_compat \
  w_j0F_compat \
  w_j1F_compat\
  w_jnF_compat \
  w_lgammaF_compat2 \
  w_lgammaF_r_compat \
  w_lgamma_compatF \
  w_log10F_compat \
  w_log2F_compat \
  w_logF_compat	\
  w_powF_compat \
  w_remainderF_compat \
  w_scalbF_compat \
  w_sinhF_compat \
  w_sqrtF_compat \
  w_tgammaF_compat \
  # libm-compat-calls

libm-narrow-fns = \
  add \
  div \
  fma \
  mul \
  sqrt \
  sub \
  # libm-narrow-fns
libm-narrow-types-basic = \
  s_f32xFf64 \
  s_fF \
  # libm-narrow-types-basic
libm-narrow-types-ldouble-yes = \
  s_dFl \
  s_fFl \
  # libm-narrow-types-ldouble-yes
libm-narrow-types-float128-yes = \
  s_f32Ff128 \
  s_f64Ff128 \
  s_f64xFf128 \
  # libm-narrow-types-float128-yes
libm-narrow-types-float128-alias-yes = \
  s_f64xFf128 \
  # libm-narrow-types-float128-alias-yes
libm-narrow-types = \
  $(libm-narrow-types-basic) \
  $(libm-narrow-types-float128-$(float128-fcts)) \
  $(libm-narrow-types-float128-alias-$(float128-alias-fcts)) \
  $(libm-narrow-types-ldouble-$(long-double-fcts)) \
  # libm-narrow-types

# Type specific routine support.
#
# The following three variables control what is included for each type:
#
# type-floatN-suffix = The suffix of the type
# type-floatN-routines = Type specific support objects
# type-floatN-yes = If the type is supported, evaluates to floatN
#
# Finally, note that types is an intentionally recursive variable.
# We only know the full set of supported types for the target machine
# after the Rules makefile has been parsed.
types-basic = \
  $(type-ldouble-$(long-double-fcts)) \
  double \
  float \
  # types-basic

# Like types, but includes types whose functions alias those for
# another type.
test-types-basic = \
  double \
  float \
  ldouble \
  # test-types-basic

# long double support
type-ldouble-suffix := l
type-ldouble-routines := \
  e_rem_pio2l \
  gamma_productl \
  k_cosl \
  k_sincosl \
  k_sinl \
  lgamma_negl \
  lgamma_productl \
  s_iscanonicall \
  t_sincosl \
  # type-ldouble-routines
type-ldouble-yes := ldouble

# double support
type-double-suffix :=
type-double-routines := \
  branred \
  e_exp_data \
  e_log2_data \
  e_log_data \
  e_pow_log_data \
  k_rem_pio2 \
  math_err \
  s_asincosh_data \
  s_atanh_data \
  s_erf_common \
  s_erf_data \
  s_erfc_data \
  sincostab \
  # type-double-routines

# float support
type-float-suffix := f
type-float-routines := \
  e_exp2f_data \
  e_log2f_data \
  e_logf_data \
  e_powf_log2_data \
  e_sincoshf_data \
  math_errf \
  s_asincosf_data \
  s_asincoshf_data \
  s_asincospif_data \
  s_sincosf_data \
  s_sincospif_data \
  # type-float-routines

# _Float128 support
type-float128-suffix := f128
type-float128-routines := \
  e_rem_pio2f128 \
  gamma_productf128 \
  k_cosf128 \
  k_sincosf128 \
  k_sinf128 \
  lgamma_negf128 \
  lgamma_productf128 \
  t_sincosf128 \
  # type-float128-routines
type-float128-yes := float128

# _Float64x may be supported, only as an alias type.
type-float64x-yes := float64x

# IBM long double support in additional to IEEE 128 long double support
type-ibm128-suffix := l
type-ibm128-yes := ibm128

types = \
  $(type-float128-$(float128-fcts)) \
  $(types-basic) \
  # types
test-types = \
  $(test-types-basic) \
  $(type-float128-$(float128-alias-fcts)) \
  $(type-float128-$(float128-fcts)) \
  $(type-float64x-$(float64x-alias-fcts)) \
  $(type-ibm128-$(ibm128-fcts)) \
  float32 \
  float32x \
  float64 \
  # test-types

# Pairs of types for which narrowing functions should be tested (this
# variable has more entries than libm-narrow-types because it includes
# pairs for which the functions sometimes or always alias functions
# for other types). This definition embeds the assumption that if
# _Float64x is supported, so is _Float128, and vice versa (they may or
# may not have the same format).
test-type-pairs = \
  $(test-type-pairs-f64xf128-$(float128-alias-fcts)) \
  $(test-type-pairs-f64xf128-$(float128-fcts)) \
  double-ldouble \
  float-double \
  float-ldouble \
  float32-float32x \
  float32-float64 \
  float32x-float64 \
  # test-type-pairs
test-type-pairs-f64xf128-yes = \
  float32-float128 \
  float32-float64x \
  float32x-float128 \
  float32x-float64x \
  float64-float128 \
  float64-float64x \
  float64x-float128 \
  # test-type-pairs-f64xf128-yes

# For each of the basic types (float, double, long double), replace the
# occurrences of 'F' in arg 1 with the appropriate suffix for the type.
type-basic-foreach = $(foreach t, $(types-basic), \
		       $(subst F,$(type-$(t)-suffix),$(1)))

# Apply suffix to each type in arg 1
type-foreach = $(foreach t,$(types),$(subst F,$(type-$(t)-suffix),$(1)))

libm-routines = $(strip $(libm-support)					\
			$(call type-basic-foreach,			\
			       $(libm-compat-calls))			\
			$(call type-foreach, $(libm-calls))		\
			$(foreach t, $(types), $(type-$(t)-routines))) 	\
			$(foreach f,$(libm-narrow-fns),			\
				    $(subst F,$(f),$(libm-narrow-types)))

# These functions are in libc instead of libm because __printf_fp
# calls them, so any program using printf will need them linked in,
# and we don't want to have to link every program with -lm.
# In libm-calls (above), list m_foo in place of s_foo for any
# routine that should be compiled separately for its libc and libm versions.
calls = \
  $(gen-calls) \
  s_copysignF \
  s_finiteF \
  s_frexpF \
  s_isinfF \
  s_isnanF \
  s_modfF \
  s_scalbnF \
  s_signbitF \
  # calls
gen-calls = s_ldexpF
generated += $(foreach s,.c .S,$(call type-foreach, $(calls:s_%=m_%$(s))))
routines = $(call type-foreach, $(calls))
# The $(calls) that are shared between libm and libc are not included in static
# libm so the symbols end up in exactly one place.
libm-shared-only-routines = $(call type-foreach, $(calls:s_%=m_%))

ifeq ($(build-mathvec),yes)
# We need to install libm.so and libm.a as linker scripts
# for transparent use of vector math library.
install-lib-ldscripts := \
  libm.a \
  libm.so \
  # install-lib-ldscripts
install-others = \
  $(inst_libdir)/libm.a \
  $(inst_libdir)/libm.so \
  # install-others
$(inst_libdir)/libm.so: $(common-objpfx)format.lds \
			$(libm) \
			$(libmvec) \
			$(+force)
	(echo '/* GNU ld script'; echo '*/';\
	 cat $<; \
	 echo 'GROUP ( $(slibdir)/libm.so$(libm.so-version) ' \
	      'AS_NEEDED ( $(slibdir)/libmvec.so$(libmvec.so-version) ) )' \
	) > $@.new
	mv -f $@.new $@

$(inst_libdir)/libm-$(version).a: $(objpfx)libm.a \
				  $(+force)
	$(do-install)

$(inst_libdir)/libm.a: $(common-objpfx)format.lds \
		       $(inst_libdir)/libm-$(version).a \
		       $(objpfx)../mathvec/libmvec.a \
		       $(+force)
	(echo '/* GNU ld script'; echo '*/';\
	 cat $<; \
	 echo 'GROUP ( $(libdir)/libm-$(version).a $(libdir)/libmvec.a )' \
	) > $@.new
	mv -f $@.new $@
endif

# Rules for the test suite.
tests = \
  $(tests-static) \
  bug-nextafter \
  bug-nexttoward \
  test-ceil-except-2 \
  test-femode \
  test-femode-traps \
  test-fenv basic-test \
  test-fenv-clear \
  test-fenv-preserve \
  test-fenv-return \
  test-fenv-tls \
  test-fesetexcept \
  test-fesetexcept-traps \
  test-fetestexceptflag \
  test-fexcept \
  test-fexcept-traps \
  test-floor-except-2 \
  test-flt-eval-method \
  test-fp-ilogb-constants \
  test-fp-llogb-constants \
  test-fpucw \
  test-fpucw-ieee \
  test-iseqsig-excess-precision \
  test-iszero-excess-precision \
  test-matherr-3 \
  test-misc \

=== nscd/Makefile ===
# Copyright (C) 1998-2026 Free Software Foundation, Inc.
# This file is part of the GNU C Library.

# The GNU C Library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.

# The GNU C Library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.

# You should have received a copy of the GNU Lesser General Public
# License along with the GNU C Library; if not, see
# <https://www.gnu.org/licenses/>.

#
#	Sub-makefile for nscd portion of the library.
#
subdir	:= nscd

include ../Makeconfig

ifneq ($(use-nscd),no)
routines := nscd_getpw_r nscd_getgr_r nscd_gethst_r nscd_getai \
	    nscd_initgroups nscd_getserv_r nscd_netgroup
aux	:= nscd_helper
endif

# To find xmalloc.c
vpath %.c ../locale/programs

nscd-modules := nscd connections pwdcache getpwnam_r getpwuid_r grpcache \
		getgrnam_r getgrgid_r hstcache gethstbyad_r gethstbynm3_r \
		getsrvbynm_r getsrvbypt_r servicescache \
		dbg_log nscd_conf nscd_stat cache mem nscd_setup_thread \
		xmalloc xstrdup aicache initgrcache res_hconf \
		netgroupcache cachedumper

ifeq ($(build-nscd)$(have-thread-library),yesyes)

others += nscd
others-pie += nscd
install-sbin := nscd

extra-objs = $(nscd-modules:=.o)

endif

all-nscd-modules := $(nscd-modules) selinux
ifeq (yes,$(have-selinux))
ifeq (yes,$(have-libaudit))
libaudit = -laudit
ifeq (yes,$(have-libcap))
libcap = -lcap
endif
endif

nscd-modules += selinux
selinux-LIBS := -lselinux $(libaudit) $(libcap)

# The configure.ac check for libselinux and its headers did not use
# $SYSINCLUDES.  The directory specified by --with-headers usually
# contains only the basic kernel interface headers, not something like
# libselinux.  So the simplest thing is to presume that the standard
# system headers will be ok for this file.
$(objpfx)nscd_stat.o: sysincludes = # nothing
$(objpfx)selinux.o: sysincludes = # nothing
endif

LDLIBS-nscd = $(selinux-LIBS)

include ../Rules

CFLAGS-nscd_getpw_r.c += -fexceptions
CFLAGS-nscd_getgr_r.c += -fexceptions
CFLAGS-nscd_gethst_r.c += -fexceptions
CFLAGS-nscd_getai.c += -fexceptions
CFLAGS-nscd_initgroups.c += -fexceptions

ifeq (yesyes,$(have-fpie)$(build-shared))
CFLAGS-nscd += $(pie-ccflag)
endif

ifeq (yesyes,$(have-fpie)$(build-shared))
LDFLAGS-nscd = -Wl,-z,now
endif

# Set libof-nscd.
cpp-srcs-left := $(nscd-modules)
lib := nscd
include $(patsubst %,$(..)libof-iterator.mk,$(cpp-srcs-left))

$(objpfx)nscd: $(nscd-modules:%=$(objpfx)%.o)

ifeq ($(build-shared),yes)
$(objpfx)nscd: $(shared-thread-library)
else
$(objpfx)nscd: $(static-thread-library)
endif

=== nss/Makefile ===
# Copyright (C) 1996-2026 Free Software Foundation, Inc.
# This file is part of the GNU C Library.

# The GNU C Library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.

# The GNU C Library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.

# You should have received a copy of the GNU Lesser General Public
# License along with the GNU C Library; if not, see
# <https://www.gnu.org/licenses/>.

#
#	Makefile for name service switch.
#
subdir	:= nss

include ../Makeconfig

headers := \
  aliases.h \
  grp.h \
  gshadow.h \
  nss.h \
  pwd.h \
  shadow.h \
  # headers

# This is the trivial part which goes into libc itself.
routines = \
  $(addsuffix -lookup,$(databases)) \
  compat-lookup \
  digits_dots \
  getnssent \
  getnssent_r \
  nss_action \
  nss_action_parse \
  nss_database \
  nss_fgetent_r \
  nss_files_data \
  nss_files_fopen \
  nss_files_functions \
  nss_hash \
  nss_module \
  nss_parse_line_result \
  nss_readline \
  nsswitch \
  rewrite_field \
  valid_field \
  valid_list_field \
  # routines

# alias routines:
routines += \
  getaliasent \
  getaliasent_r \
  getaliasname \
  getaliasname_r \
  # routines

ifeq ($(have-thread-library),yes)
CFLAGS-getaliasent_r.c += -fexceptions
CFLAGS-getaliasent.c += -fexceptions
endif

# ethers routines:
routines += \
  ether_hton \
  ether_ntoh \
  # routines

# grp routines:
routines += \
  fgetgrent \
  fgetgrent_r \
  getgrent \
  getgrent_r \
  getgrgid \
  getgrgid_r \
  getgrnam \
  getgrnam_r \
  grp-merge \
  initgroups \
  putgrent \
  # routines

ifeq ($(have-thread-library),yes)
CFLAGS-fgetgrent.c += -fexceptions
CFLAGS-fgetgrent_r.c += -fexceptions $(libio-mtsafe)
CFLAGS-getgrent.c += -fexceptions
CFLAGS-getgrent_r.c += -fexceptions
CFLAGS-getgrgid.c += -fexceptions
CFLAGS-getgrgid_r.c += -fexceptions
CFLAGS-getgrnam.c += -fexceptions
CFLAGS-getgrnam_r.c += -fexceptions
CFLAGS-initgroups.c += -fexceptions
CFLAGS-putgrent.c += -fexceptions $(libio-mtsafe)
endif

# gshadow routines:
routines += \
  fgetsgent \
  fgetsgent_r \
  getsgent \
  getsgent_r \
  getsgnam \
  getsgnam_r \
  putsgent \
  sgetsgent \
  sgetsgent_r \
  # routines

ifeq ($(have-thread-library),yes)
CFLAGS-getsgent_r.c += -fexceptions
CFLAGS-getsgent.c += -fexceptions
CFLAGS-fgetsgent.c += -fexceptions
CFLAGS-fgetsgent_r.c += -fexceptions $(libio-mtsafe)
CFLAGS-putsgent.c += -fexceptions $(libio-mtsafe)
CFLAGS-getsgnam.c += -fexceptions
CFLAGS-getsgnam_r.c += -fexceptions
endif

# hosts routines:
routines += \
  getaddrinfo \
  gethstbyad \
  gethstbyad_r \
  gethstbynm \
  gethstbynm2 \
  gethstbynm2_r \
  gethstbynm_r \
  gethstent \
  gethstent_r \
  getnameinfo \
  # routines

ifeq ($(have-thread-library),yes)
CFLAGS-getaddrinfo.c += -fexceptions
CFLAGS-gethstbyad.c += -fexceptions
CFLAGS-gethstbyad_r.c += -fexceptions
CFLAGS-gethstbynm.c += -fexceptions
CFLAGS-gethstbynm_r.c += -fexceptions
CFLAGS-gethstbynm2.c += -fexceptions
CFLAGS-gethstbynm2_r.c += -fexceptions
CFLAGS-gethstent.c += -fexceptions
CFLAGS-gethstent_r.c += -fexceptions
endif

# netgroup routines:
routines += \
  getnetgrent \
  getnetgrent_r \
  # routines

ifeq ($(have-thread-library),yes)
CFLAGS-getnetgrent.c += -fexceptions
CFLAGS-getnetgrent_r.c += -fexceptions
endif

# networks routines:
routines += \
  getnetbyad \
  getnetbyad_r \
  getnetbynm \
  getnetbynm_r \
  getnetent \
  getnetent_r \
  # routines

ifeq ($(have-thread-library),yes)
CFLAGS-getnetbyad.c += -fexceptions
CFLAGS-getnetbyad_r.c += -fexceptions
CFLAGS-getnetbynm.c += -fexceptions
CFLAGS-getnetbynm_r.c += -fexceptions
CFLAGS-getnetent.c += -fexceptions
CFLAGS-getnetent_r.c += -fexceptions
endif

# protocols routines:
routines += \
  getproto \
  getproto_r \
  getprtent \
  getprtent_r \
  getprtname \
  getprtname_r \
  # routines

ifeq ($(have-thread-library),yes)
CFLAGS-getprtent_r.c += -fexceptions
CFLAGS-getprtent.c += -fexceptions
endif

# pwd routines:
routines += \
  fgetpwent \
  fgetpwent_r \
  getpw \
  getpwent \
  getpwent_r \
  getpwnam \
  getpwnam_r \
  getpwuid \
  getpwuid_r \
  putpwent \
  # routines

ifeq ($(have-thread-library),yes)
CFLAGS-fgetpwent_r.c += $(libio-mtsafe)
CFLAGS-getpw.c += -fexceptions
CFLAGS-getpwent.c += -fexceptions
CFLAGS-getpwent_r.c += -fexceptions
endif

# rpc routines:
routines += \
  getrpcbyname \
  getrpcbyname_r \
  getrpcbynumber \
  getrpcbynumber_r \
  getrpcent \
  getrpcent_r \
  # routines

ifeq ($(have-thread-library),yes)
CFLAGS-getrpcent_r.c += -fexceptions
CFLAGS-getrpcent.c += -fexceptions
endif

# services routines:
routines += \
  getservent \
  getservent_r \
  getsrvbynm \
  getsrvbynm_r \
  getsrvbypt \
  getsrvbypt_r \
  # routines

ifeq ($(have-thread-library),yes)
CFLAGS-getservent_r.c += -fexceptions
CFLAGS-getservent.c += -fexceptions
endif

# shadow routines
routines += \
  fgetspent \
  fgetspent_r \
  getspent \
  getspent_r \
  getspnam \
  getspnam_r \
  lckpwdf \
  putspent \
  sgetspent \
  sgetspent_r \
  # routines

ifeq ($(have-thread-library),yes)
CFLAGS-getspent_r.c += -fexceptions
CFLAGS-getspent.c += -fexceptions
CFLAGS-fgetspent.c += -fexceptions
CFLAGS-fgetspent_r.c += -fexceptions $(libio-mtsafe)
CFLAGS-putspent.c += -fexceptions $(libio-mtsafe)
CFLAGS-getspnam.c += -fexceptions
CFLAGS-getspnam_r.c += -fexceptions
endif

# These are the databases that go through nss dispatch.
# Caution: if you add a database here, you must add its real name
# in databases.def, too.
databases = \
  alias \
  ethers \
  grp \
  hosts \
  netgrp \
  network \
  proto \
  pwd \
  service \
  sgrp \
  spwd \
  # databases

ifneq (,$(filter sunrpc,$(subdirs)))
databases		+= key rpc
have-sunrpc		:= 1
else
have-sunrpc		:= 0
endif
CPPFLAGS-getent.c	= -DHAVE_SUNRPC=$(have-sunrpc)

others                  := getent makedb
install-bin             := getent makedb
makedb-modules = xmalloc hash-string
others-extras		= $(makedb-modules)
extra-objs		+= $(makedb-modules:=.o)

tests-static            = tst-field

tests-internal := \
  tst-field \
  tst-rfc3484 \
  tst-rfc3484-2 \
  tst-rfc3484-3 \
  # tests-internal

tests := \
  bug17079 \
  test-digits-dots \
  test-netdb \
  test-rpcent \
  testgrp \
  tst-fgetsgent_r \
  tst-getaddrinfo \
  tst-getaddrinfo2 \
  tst-getaddrinfo3 \
  tst-gethnm \
  tst-getpw \
  tst-gshadow \
  tst-nss-getpwent \
  tst-nss-hash \
  tst-nss-test1 \
  tst-nss-test2 \
  tst-nss-test4 \
  tst-nss-test5 \
  tst-nss-test_errno \
  tst-putgrent \
  tst-putpwent \
  tst-putsgent \
  tst-putspent \
  tst-sgetsgent \
  tst-shadow \
  # tests

xtests := \
  bug-erange \
  tst-getaddrinfo4 \
  tst-getaddrinfo5 \
  # xtests

tests-container := \
  tst-initgroups1 \
  tst-initgroups2 \
  tst-nss-action-parse \
  tst-nss-compat1 \
  tst-nss-db-endgrent \
  tst-nss-db-endpwent \
  tst-nss-files-hosts-long \
  tst-nss-files-hosts-v4mapped \
  tst-nss-gai-actions \
  tst-nss-gai-hv2-canonname \
  tst-nss-test3 \
  tst-reload1 \
  tst-reload2 \
  # tests-container

ifeq (yes,$(build-shared))
# Tests which need libdl
tests += tst-nss-files-hosts-erange
tests += tst-nss-files-hosts-multi
tests += tst-nss-files-hosts-getent
tests += tst-nss-files-alias-leak
tests += tst-nss-files-alias-truncated
tests += tst-nss-files-network
# tst_fgetgrent currently only works with shared libraries
test-srcs :=  tst_fgetgrent
ifeq ($(run-built-tests),yes)
tests-special += $(objpfx)tst_fgetgrent.out
$(objpfx)tst_fgetgrent.out: tst_fgetgrent.sh $(objpfx)tst_fgetgrent
	$(SHELL) $< $(common-objpfx) '$(test-program-prefix)'; \
	$(evaluate-test)
endif
endif

# If we have a thread library then we can test cancellation against
# some routines like getpwuid_r.
ifeq (yes,$(have-thread-library))
tests += tst-cancel-getpwuid_r
endif

# Specify rules for the nss_* modules.  We have some services.
services		:= files db compat

extra-libs		= $(services:%=libnss_%)
# These libraries will be built in the `others' pass rather than
# the `lib' pass, because they depend on libc.so being built already.
extra-libs-others	= $(extra-libs)

# The sources are found in the appropriate subdir.
subdir-dirs = $(services:%=nss_%)
vpath %.c $(subdir-dirs) ../locale/programs ../intl


routines += \
  $(addprefix files-, $(filter-out key, $(databases))) \
  files-init \
  files-initgroups \
  # routines

# Build only an empty shared libnss_files.
libnss_files-inhibit-o = $(filter-out .os,$(object-suffixes))

# Pretend that libnss_files.so is a linker script, so that the symbolic link
# is not installed.
install-lib-ldscripts = libnss_files.so
$(inst_libdir)/libnss_files.so:

libnss_db-dbs		:= $(addprefix db-,\
				       $(filter-out hosts network key alias,\
						    $(databases))) \
			   db-initgroups
libnss_db-routines	:= $(libnss_db-dbs) db-open db-init hash-string
generated		+= $(filter-out db-alias.c db-netgrp.c, \
					$(addsuffix .c,$(libnss_db-dbs)))

libnss_compat-routines	:= $(addprefix compat-,grp pwd spwd initgroups) \
			   nisdomain

install-others		+= $(inst_vardbdir)/Makefile

# Build static module into libc if requested
libnss_db-inhibit-o	= $(filter-out .os,$(object-suffixes))
libnss_compat-inhibit-o	= $(filter-out .os,$(object-suffixes))
ifeq ($(build-static-nss),yes)
tests-static		+= tst-nss-static
endif
extra-test-objs		+= nss_test1.os nss_test2.os nss_test_errno.os \
			   nss_test_gai_hv2_canonname.os

ifeq ($(run-built-tests),yes)
ifneq (no,$(PERL))
tests-special += $(objpfx)mtrace-tst-nss-gai-hv2-canonname.out
endif
endif

generated += mtrace-tst-nss-gai-hv2-canonname.out \
		tst-nss-gai-hv2-canonname.mtrace

include ../Rules

LOCALES := tr_TR.UTF-8
include ../gen-locales.mk

ifeq (yes,$(have-selinux))
LDLIBS-makedb		:= -lselinux
endif

libnss-libc = $(common-objpfx)linkobj/libc.so
# Target-specific variable setting to link objects using deprecated
# RPC interfaces with the version of libc.so that makes them available
# for new links:
$(services:%=$(objpfx)libnss_%.so): libc-for-link = $(libnss-libc)

$(libnss_db-dbs:%=$(objpfx)%.c): $(objpfx)db-%.c: nss_files/files-%.c
	@rm -f $@.new
	(echo '#define EXTERN_PARSER';\
	 echo '#define GENERIC "../nss_db/db-XXX.c"';\
	 echo '#include "$<"') > $@.new
	mv -f $@.new $@


$(objpfx)makedb: $(makedb-modules:%=$(objpfx)%.o)

$(inst_vardbdir)/Makefile: db-Makefile $(+force)
	$(do-install)

libnss_test1.so-no-z-defs = 1
libnss_test2.so-no-z-defs = 1

rtld-tests-LDFLAGS += -Wl,--dynamic-list=nss_test.ver

libof-nss_test1 = extramodules
libof-nss_test2 = extramodules
libof-nss_test_errno = extramodules
libof-nss_test_gai_hv2_canonname = extramodules
$(objpfx)libnss_test1.so: $(objpfx)nss_test1.os $(link-libc-deps)
	$(build-module)
$(objpfx)libnss_test2.so: $(objpfx)nss_test2.os $(link-libc-deps)
	$(build-module)
$(objpfx)libnss_test_errno.so: $(objpfx)nss_test_errno.os $(link-libc-deps)
	$(build-module)
$(objpfx)libnss_test_gai_hv2_canonname.so: \
  $(objpfx)nss_test_gai_hv2_canonname.os $(link-libc-deps)
	$(build-module)
$(objpfx)nss_test2.os : nss_test1.c
# Use the nss_files suffix for these objects as well.
$(objpfx)libnss_test1.so$(libnss_files.so-version): $(objpfx)libnss_test1.so
	$(make-link)
$(objpfx)libnss_test2.so$(libnss_files.so-version): $(objpfx)libnss_test2.so
	$(make-link)
$(objpfx)libnss_test_errno.so$(libnss_files.so-version): \
  $(objpfx)libnss_test_errno.so
	$(make-link)
$(objpfx)libnss_test_gai_hv2_canonname.so$(libnss_files.so-version): \
  $(objpfx)libnss_test_gai_hv2_canonname.so
	$(make-link)
$(patsubst %,$(objpfx)%.out,$(tests) $(tests-container)) : \
	$(objpfx)libnss_test1.so$(libnss_files.so-version) \
	$(objpfx)libnss_test2.so$(libnss_files.so-version) \

=== socket/Makefile ===
# Copyright (C) 1991-2026 Free Software Foundation, Inc.
# This file is part of the GNU C Library.

# The GNU C Library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.

# The GNU C Library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.

# You should have received a copy of the GNU Lesser General Public
# License along with the GNU C Library; if not, see
# <https://www.gnu.org/licenses/>.

#
#	Sub-makefile for socket portion of the library.
#
subdir	:= socket

include ../Makeconfig

headers := \
  bits/sockaddr.h \
  bits/socket.h \
  bits/socket2.h \
  bits/types/struct_osockaddr.h \
  net/if.h \
  sys/socket.h \
  sys/socketvar.h \
  sys/un.h \
  # headers

routines := \
  accept \
  accept4 \
  bind \
  connect \
  getpeername \
  getsockname \
  getsockopt \
  isfdtype \
  listen \
  opensock \
  recv \
  recvfrom \
  recvmmsg \
  recvmsg \
  send \
  sendmmsg \
  sendmsg \
  sendto \
  setsockopt \
  shutdown \
  sockaddr_un_set \
  sockatmark \
  socket \
  socketpair \
  # routines

# Exclude fortified routines from being built with _FORTIFY_SOURCE
routines_no_fortify += \
  recv \
  recvfrom \
  # routines_no_fortify

tests := \
  tst-accept4 \
  tst-cmsg_cloexec \
  tst-cmsghdr \
  tst-connect \
  tst-shutdown \
  tst-sockopt \
  # tests

tests-internal := \
  tst-sockaddr_un_set \
  # tests-internal

tests-time64 := \
  tst-sockopt-time64 \
  # tests

aux	 := sa_len

include ../Rules

CFLAGS-recv.c += -fexceptions -fasynchronous-unwind-tables
CFLAGS-recvfrom.c += -fexceptions -fasynchronous-unwind-tables
CFLAGS-sendto.c += -fexceptions -fasynchronous-unwind-tables
CFLAGS-recvmsg.c += -fexceptions -fasynchronous-unwind-tables
CFLAGS-sendmsg.c += -fexceptions -fasynchronous-unwind-tables
CFLAGS-send.c += -fexceptions -fasynchronous-unwind-tables
CFLAGS-connect.c += -fexceptions -fasynchronous-unwind-tables
CFLAGS-accept.c += -fexceptions -fasynchronous-unwind-tables

=== termios/Makefile ===
# Copyright (C) 1991-2026 Free Software Foundation, Inc.
# This file is part of the GNU C Library.

# The GNU C Library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.

# The GNU C Library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.

# You should have received a copy of the GNU Lesser General Public
# License along with the GNU C Library; if not, see
# <https://www.gnu.org/licenses/>.

#
#	Makefile for the terminal I/O functions.
#
subdir	:= termios

include ../Makeconfig

headers	:= \
  bits/termios-baud.h \
  bits/termios.h \
  sys/termios.h \
  sys/ttychars.h \
  sys/ttydefaults.h \
  termios.h \
  # headers

routines := \
  baud \
  cfmakeraw \
  cfsetbaud \
  cfsetspeed \
  isatty \
  isatty_nostatus \
  speed \
  tcdrain \
  tcflow \
  tcflush \
  tcgetattr \
  tcgetpgrp \
  tcgetsid \
  tcsendbrk \
  tcsetattr \
  tcsetpgrp \
  # routines

include ../Rules

CFLAGS-tcdrain.c += -fexceptions -fasynchronous-unwind-tables

=== sysdeps/arm/Makefile ===
gnulib-arch = $(elf-objpfx)libgcc-stubs.a
static-gnulib-arch = $(elf-objpfx)libgcc-stubs.a

ifeq ($(subdir),elf)
sysdep-dl-routines += tlsdesc dl-tlsdesc
sysdep_routines += aeabi_unwind_cpp_pr1 find_exidx
sysdep-rtld-routines += aeabi_unwind_cpp_pr1
shared-only-routines += aeabi_unwind_cpp_pr1

$(objpfx)libgcc-stubs.a: $(objpfx)aeabi_unwind_cpp_pr1.os
	$(build-extra-lib)

lib-noranlib: $(objpfx)libgcc-stubs.a

ifeq ($(build-shared),yes)
ifneq (no,$(have-test-mtls-descriptor))
tests += tst-armtlsdescloc tst-armtlsdescextnow tst-armtlsdescextlazy
modules-names += tst-armtlsdesclocmod
modules-names += tst-armtlsdescextlazymod tst-armtlsdescextnowmod
CPPFLAGS-tst-armtlsdescextnowmod.c += -Dstatic=
CPPFLAGS-tst-armtlsdescextlazymod.c += -Dstatic=
CFLAGS-tst-armtlsdesclocmod.c += -mtls-dialect=$(have-test-mtls-descriptor)
CFLAGS-tst-armtlsdescextnowmod.c += -mtls-dialect=$(have-test-mtls-descriptor)
CFLAGS-tst-armtlsdescextlazymod.c += -mtls-dialect=$(have-test-mtls-descriptor)
LDFLAGS-tst-armtlsdescextnowmod.so += -Wl,-z,now
tst-armtlsdescloc-ENV = LD_BIND_NOW=1
tst-armtlsdescextnow-ENV = LD_BIND_NOW=1
tst-armtlsdescextlazy-ENV = LD_BIND_NOW=1
$(objpfx)tst-armtlsdescloc: $(objpfx)tst-armtlsdesclocmod.so
$(objpfx)tst-armtlsdescextnow: $(objpfx)tst-armtlsdescextnowmod.so
$(objpfx)tst-armtlsdescextlazy: $(objpfx)tst-armtlsdescextlazymod.so
endif
endif
endif

ifeq ($(subdir),csu)
# get offset to rtld_global._dl_hwcap
gen-as-const-headers += rtld-global-offsets.sym tlsdesc.sym
aeabi_constants = aeabi_lcsts aeabi_sighandlers aeabi_math
aeabi_routines = aeabi_assert aeabi_localeconv aeabi_errno_addr \
		 aeabi_mb_cur_max aeabi_atexit aeabi_memclr aeabi_memcpy \
		 aeabi_memmove aeabi_memset \
		 aeabi_read_tp libc-aeabi_read_tp

sysdep_routines += $(aeabi_constants) $(aeabi_routines)
static-only-routines += $(aeabi_constants) aeabi_read_tp
shared-only-routines += libc-aeabi_read_tp

sysdep_routines += arm-unwind-resume
shared-only-routines += arm-unwind-resume
endif

ifeq ($(subdir),gmon)
sysdep_routines += arm-mcount
endif

ifeq ($(subdir),rt)
librt-sysdep_routines += rt-aeabi_unwind_cpp_pr1 rt-arm-unwind-resume
librt-shared-only-routines += rt-aeabi_unwind_cpp_pr1 rt-arm-unwind-resume
endif

=== sysdeps/m68k/Makefile ===
# Copyright (C) 1993-2026 Free Software Foundation, Inc.
# This file is part of the GNU C Library.

# The GNU C Library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.

# The GNU C Library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.

# You should have received a copy of the GNU Lesser General Public
# License along with the GNU C Library.  If not, see
# <https://www.gnu.org/licenses/>.

# The mpn functions need this.  All existing 68k ports use MIT syntax.  If
# a new port wants to use Motorola or Sony syntax, it can redefine this
# variable.
ifndef m68k-syntax-flag
m68k-syntax-flag = -DMIT_SYNTAX
endif

asm-CPPFLAGS += $(m68k-syntax-flag)

pic-ccflag = -fpic

ifeq ($(subdir),csu)
# Make sure gcrt1.o uses the large PIC model
CFLAGS-gmon-start.c := -fPIC
ifeq ($(build-pie-default),yes)
# Override default PIE
ASFLAGS-.o += -fno-pie
endif
endif

ifeq ($(subdir),setjmp)
# Make sure setjmp.c is compiled with a frame pointer
CFLAGS-setjmp.c := -fno-omit-frame-pointer
endif

ifeq ($(subdir),elf)
CFLAGS-rtld.c += -Wno-uninitialized -Wno-unused
endif

ifeq ($(subdir),gmon)
CFLAGS-mcount.c += -Wno-frame-address
endif

=== sysdeps/aarch64/fpu/Makefile ===
libmvec-supported-funcs = acos \
                          acosh \
                          acospi \
                          asin \
                          asinh \
                          asinpi \
                          atan \
                          atanh \
                          atanpi \
                          atan2 \
                          atan2pi \
                          cbrt \
                          cos \
                          cosh \
                          cospi \
                          erf \
                          erfc \
                          exp \
                          exp10 \
                          exp2 \
                          expm1 \
                          exp2m1 \
                          exp10m1 \
                          hypot \
                          log \
                          log10 \
                          log10p1 \
                          log1p \
                          log2 \
                          log2p1 \
                          pow \
                          rsqrt \
                          sin \
                          sinh \
                          sinpi \
                          tan \
                          tanh \
                          tanpi

float-advsimd-funcs = $(libmvec-supported-funcs)
double-advsimd-funcs = $(libmvec-supported-funcs)
float-sve-funcs = $(libmvec-supported-funcs)
double-sve-funcs = $(libmvec-supported-funcs)

ifeq ($(subdir),mathvec)
libmvec-support = $(addsuffix f_advsimd,$(float-advsimd-funcs)) \
                  $(addsuffix _advsimd,$(double-advsimd-funcs)) \
                  $(addsuffix f_sve,$(float-sve-funcs)) \
                  $(addsuffix _sve,$(double-sve-funcs)) \
                  v_log_data \
                  v_exp_data \
                  v_log2_data \
                  v_log10_data \
                  erf_data \
                  erff_data \
                  v_exp_tail_data \
                  erfc_data \
                  erfcf_data \
                  v_pow_exp_data \
                  v_pow_log_data \
                  v_powf_data
endif

# Enable SVE for building libmvec.  Since CFLAGS may contain a -mcpu or -march,
# add a generic -mcpu and -march with SVE enabled.  Also use a tune for a modern
# SVE core.

sve-cflags = -mcpu=generic+sve -march=armv8-a+sve -mtune=neoverse-v1

ifeq ($(build-mathvec),yes)
bench-libmvec = $(addprefix float-advsimd-,$(float-advsimd-funcs)) \
                $(addprefix double-advsimd-,$(double-advsimd-funcs)) \
                $(addprefix float-sve-,$(float-sve-funcs)) \
                $(addprefix double-sve-,$(double-sve-funcs))
endif

$(objpfx)bench-float-advsimd-%.c:
	$(PYTHON) $(..)sysdeps/aarch64/fpu/scripts/bench_libmvec_advsimd.py $(basename $(@F)) > $@
$(objpfx)bench-double-advsimd-%.c:
	$(PYTHON) $(..)sysdeps/aarch64/fpu/scripts/bench_libmvec_advsimd.py $(basename $(@F)) > $@
$(objpfx)bench-float-sve-%.c:
	$(PYTHON) $(..)sysdeps/aarch64/fpu/scripts/bench_libmvec_sve.py $(basename $(@F)) > $@
$(objpfx)bench-double-sve-%.c:
	$(PYTHON) $(..)sysdeps/aarch64/fpu/scripts/bench_libmvec_sve.py $(basename $(@F)) > $@

ifeq (${STATIC-BENCHTESTS},yes)
libmvec-benchtests = $(common-objpfx)mathvec/libmvec.a $(common-objpfx)math/libm.a
else
libmvec-benchtests = $(libmvec) $(libm)
endif

$(addprefix $(objpfx)bench-,$(bench-libmvec)): $(libmvec-benchtests)

ifeq ($(build-mathvec),yes)
libmvec-tests += float-advsimd double-advsimd float-sve double-sve
endif

define sve-float-cflags-template
CFLAGS-$(1)f_sve.c += $(sve-cflags)
CFLAGS-bench-float-sve-$(1).c += $(sve-cflags)
endef

define sve-double-cflags-template
CFLAGS-$(1)_sve.c += $(sve-cflags)
CFLAGS-bench-double-sve-$(1).c += $(sve-cflags)
endef

$(foreach f,$(float-sve-funcs), $(eval $(call sve-float-cflags-template,$(f))))
$(foreach f,$(double-sve-funcs), $(eval $(call sve-double-cflags-template,$(f))))

CFLAGS-test-float-sve-wrappers.c = $(sve-cflags)
CFLAGS-test-double-sve-wrappers.c = $(sve-cflags)

=== debian/changelog ===
glibc (2.43-1) experimental; urgency=medium

  [ Aurelien Jarno ]
  * New upstream release:
    - debian/copyright: update following upstream changes.
    - debian/symbols.wildcards: add 2.43.
    - debian/patches/git-updates.diff: update from upstream stable branch.
    - debian/patches/hurd-i386/local-enable-ldconfig.diff: rebased.
    - debian/patches/hurd-i386/git-sigreturn-SEGV.diff: upstreamed.
    - debian/patches/hurd-i386/git-rlimit-as.diff: upstreamed.
    - debian/patches/hurd-i386/git-run-iconv-test.sh.diff: upstreamed.
    - debian/patches/hurd-i386/git-elf-ordering.diff: upstreamed.
    - debian/patches/hurd-i386/git-rename.diff: upstreamed.
    - debian/patches/hurd-i386/git-signal-SSE-MMX.diff: upstreamed.
    - debian/patches/hurd-i386/git-sigreturn-xmm.diff: upstreamed.
    - debian/patches/hurd-i386/git-cancel-stack.diff: upstreamed.
    - debian/patches/i386/unsubmitted-quiet-ldconfig.diff: rebased.
    - debian/patches/any/local-asserth-decls.diff: rebased.
    - debian/patches/any/local-tcsetaddr.diff: rebased.
    - debian/patches/any/submitted-nptl-invalid-td.patch: drop, obsolete.
    - debian/patches/any/git-ldd-set-u.diff: upstreamed.
    - debian/patches/any/git-linux-termios.diff: upstreamed.
    - debian/patches/hurd-i386/submitted-net.diff: rebased.
    - debian/patches/hurd-i386/tg-bits_atomic.h_multiple_threads.diff: drop,
      obsolete.
    - debian/patches/hurd-i386/local-clock_gettime_MONOTONIC.diff: rebased.
    - debian/patches/hurd-i386/local-fix-nss.diff: rebased.
    - debian/libc0.3.symbols.hurd-i386: update following the move of symbols
      from libpthread.so.0.3 to libc.so.0.3.

 -- Aurelien Jarno <aurel32@debian.org>  Wed, 28 Jan 2026 22:35:15 +0100

glibc (2.42-11) unstable; urgency=medium

  [ Samuel Thibault ]
  * debian/patches/hurd-i386/local-execstack.diff: Work around missing execstack
    on libc.so.

  [ Aurelien Jarno ]
  * debian/patches/git-updates.diff: update from upstream stable branch:
    - Fix bug in wordexp, which could return uninitialized memory when using
      WRDE_REUSE together with WRDE_APPEND (CVE-2025-15281).  Closes: #1126266.
    - Switch currency symbol for the bg_BG locale to euro.

 -- Aurelien Jarno <aurel32@debian.org>  Mon, 26 Jan 2026 23:40:35 +0100

glibc (2.42-10) unstable; urgency=medium

  [ Aurelien Jarno ]
  * debian/sysdeps/{amd64,arm64,i386,x32}.mk: disable SFrame support.  Closes:
    #1125944.
  * debian/control.in/{main,libc}: drop versioned Build-Depends and Breaks on
    binutils 2.45, now pointless.

 -- Aurelien Jarno <aurel32@debian.org>  Mon, 19 Jan 2026 20:12:24 +0100

glibc (2.42-9) unstable; urgency=medium

  [ Samuel Thibault ]
  * debian/patches/hurd-i386/git-cancel-stack.diff: Fix crash on cancellation
    with unaligned stack.

  [ Aurelien Jarno ]
  * debian/rules.d/debhelper.mk: do not strip ld.so on armhf.  Closes:
    #1125796.

 -- Aurelien Jarno <aurel32@debian.org>  Sun, 18 Jan 2026 11:52:41 +0100

glibc (2.42-8) unstable; urgency=medium

  [ Samuel Thibault ]
  * debian/testsuite-xfail-debian.mk: Avoid running tst-writev on hurd-amd64.
  * debian/patches/hurd-i386/git-sigreturn-xmm.diff: Fix sigreturn using xmm
    registers in the signal contention case.
  * debian/patches/hurd-i386/local-intr-msg-clobber.diff: Try to re-introduce
    mmx clobber work-around.
  * debian/testsuite-xfail-debian.mk: Update hurd results.

  [ Aurelien Jarno ]
  * debian/rules.d/build.mk: do not write BUILD_CXX to configparms, it's
    unused.
  * debian/patches/git-updates.diff: update from upstream stable branch:
    - Fix and integer overflow in _int_memalign leading to heap corruption
      (CVE-2026-0861).  Closes: #1125678.
    - Fix stack contents leak in getnetbyaddr (CVE-2026-0915).  Closes:
      #1125748.
    - Optimize trylock for high cache contention workloads.

  [ Helmut Grohne ]
  * debian/control.in/main: avoid g++ dependency in nocheck builds.
  * debian/control.in/main, rules, rules.d/build.mk: don't build nscd in
    stage2.

 -- Aurelien Jarno <aurel32@debian.org>  Fri, 16 Jan 2026 21:50:10 +0100

glibc (2.42-7) unstable; urgency=medium

  [ Aurelien Jarno ]
  * debian/control.in/libc, debian/rules.d/debhelper.mk: drop libcrypt-dev
    dependency from libc6-dev. Thanks to Helmut Grohne for proposing that,
    doing an archive rebuild and filling the bug reports.
  * debian/control.in/main, debian/sysdeps/linux.mk: enable SystemTap static
    probes.
  * debian/debhelper.in/libc-dev.NEWS: add a NEWS entry about the removal of
    the obsolete termio interface.  Closes: #1124068.
  * debian/rules.d/debhelper.mk: ensure that linker scripts work even when
    /usr is unmerged.  Closes: #1120508
  * debian/debhelper.in/libc-dev{,-alt}.lintian-overrides,
    source/lintian-overrides, rules.d/debhelper.mk, salsa-ci.yml: drop
    unpack-message-for-{orig,source} overrides, fixed in lintian 2.128.0.
  * debian/control.in/main: drop Rules-Requires-Root: no, this is now the
    default.
  * debian/libc6.symbols.i386, debian/libc6-i386.symbols.{amd64,x32}: remove
    the workaround for GLIBC_ABI_GNU_TLS.  Closes: #1122038.
  * debian/control.in/{libc,i386}: ensure that libdpkg-perl is fixed wrt
    GLIBC_ABI_GNU_TLS.

 -- Aurelien Jarno <aurel32@debian.org>  Sun, 04 Jan 2026 10:07:24 +0100

glibc (2.42-6) unstable; urgency=medium

  [ Benjamin Drung ]
  * debian/control: add new lines when concatenating files
  * Update debian/watch to version 5

  [ Aurelien Jarno ]
  * debian/symbols.wildcards: adjust ABI flags version:
    - Fix corresponding to GLIBC_ABI_DT_X86_64_PLT was first corrected in 2.36
    - Fix corresponding to GLIBC_ABI_GNU2_TLS as first corrected in 2.40
  * debian/control.in/libc, debian/control.in/main: remove breaks, conflicts
    and (build-)depends already satisfied in bookworm.
  * debian/control.in/amd64, debian/control.in/libc: add a Breaks against
    binutils (<< 2.45) for builds with sframe support enabled.


=== debian/control ===
Source: glibc
Section: libs
Priority: required
Build-Depends: gettext, xz-utils, file, quilt,
 autoconf, gawk, debhelper-compat (= 13), rdfind, symlinks, netbase, gperf, bison,
 linux-libc-dev [linux-any],
 libaudit-dev [linux-any] <!nocheck> <!stage1 !stage2>, libcap-dev [linux-any] <!stage2>, libselinux1-dev [linux-any] <!stage2>,
 mig-for-host (>= 1.8+git20200618-7~) [hurd-any], gnumach-dev (>= 2:1.8+git20200710-2~) [hurd-any],
 hurd-dev (>= 1:0.9.git20201127-4~) [hurd-any] | hurd-headers-dev [hurd-any],
 binutils-for-host,
 gcc-15-for-host, gcc-15-multilib [amd64 i386 mips mipsel mipsn32 mipsn32el mips64 mips64el mipsr6 mipsr6el mipsn32r6 mipsn32r6el mips64r6 mips64r6el powerpc ppc64 s390x sparc sparc64 x32] <!nobiarch>,
 g++-15-for-host <!nocheck>, g++-15-multilib [amd64 i386 mips mipsel mipsn32 mipsn32el mips64 mips64el mipsr6 mipsr6el mipsn32r6 mipsn32r6el mips64r6 mips64r6el powerpc ppc64 s390x sparc sparc64 x32] <!nobiarch !nocheck>,
 python3:native,
 libidn2-0 <!nocheck>,
 libc-bin (>= 2.43) <cross>,
 libgd-dev <!stage1 !stage2>,
 systemtap-sdt-dev [linux-any] <!stage1 !stage2 !pkg.glibc.nosystemtap>,
Build-Depends-Indep: perl, po-debconf
Maintainer: GNU Libc Maintainers <debian-glibc@lists.debian.org>
Uploaders: Clint Adams <clint@debian.org>, Aurelien Jarno <aurel32@debian.org>, Samuel Thibault <sthibault@debian.org>
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/glibc-team/glibc
Vcs-Git: https://salsa.debian.org/glibc-team/glibc.git
Homepage: https://www.gnu.org/software/libc/libc.html

Package: libc-bin
Architecture: any
Section: libs
Priority: required
Essential: yes
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: manpages
Build-Profiles: <!stage1>
Description: GNU C Library: Binaries
 This package contains utility programs related to the GNU C Library.
 .
  * getconf: query system configuration variables
  * getent: get entries from administrative databases
  * iconv, iconvconfig: convert between character encodings
  * ldd, ldconfig: print/configure shared library dependencies
  * locale, localedef: show/generate locale definitions
  * tzselect, zdump, zic: select/dump/compile time zones

Package: libc-dev-bin
Architecture: any
Section: libdevel
Priority: optional
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: manpages, manpages-dev
Suggests: libc-devtools (>> 2.43)
Build-Profiles: <!stage1>
Description: GNU C Library: Development binaries
 This package contains utility programs related to the GNU C Library
 development package.
 .
  * gencat: generate message catalogs

Package: libc-devtools
Architecture: any
Section: devel
Priority: optional
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: libc-dev (= ${binary:Version}), manpages, manpages-dev
Build-Profiles: <!stage1> <!stage2>
Description: GNU C Library: Development tools
 This package contains development tools shipped by the GNU C
 Library.
 .
  * memusage, memusagestat: profile a program's memory usage
  * mtrace: interpret the malloc trace log
  * sotruss: trace shared library calls
  * sprof: display shared object profiling data

Package: libc-gconv-modules-extra
Architecture: any
Section: libs
Priority: optional
Multi-Arch: same
Depends: ${misc:Depends}
Breaks: libc6 (<< 2.42-1) [!alpha !hurd-any], libc6.1 (<< 2.42-1) [alpha], libc0.3 (<< 2.42-1) [hurd-any]
Replaces: libc6 (<< 2.42-1) [!alpha !hurd-any], libc6.1 (<< 2.42-1) [alpha], libc0.3 (<< 2.42-1) [hurd-any]
Build-Profiles: <!stage1>
Description: GNU C Library: Non-essential gconv modules
 This package provides additional character set conversion modules for the GNU
 C Library's gconv facility, to support encodings other than Latin-1 and UTF
 based.

Package: libc-l10n
Architecture: all
Section: localization
Priority: standard
Multi-Arch: foreign
Depends: ${misc:Depends}
Build-Profiles: <!stage1>
Description: GNU C Library: localization files
 This package contains the translation files for the GNU C library and
 utility programs.

Package: glibc-doc
Architecture: all
Section: doc
Priority: optional
Multi-Arch: foreign
Depends: ${misc:Depends}
Suggests: glibc-doc-reference
Build-Profiles: <!stage1>
Description: GNU C Library: Documentation
 Contains the complete GNU C Library ChangeLog.  The GNU C Library Reference
 manual has been moved into glibc-doc-reference for licensing reasons.

Package: glibc-source
Architecture: all
Section: devel
Priority: optional
Multi-Arch: foreign
Depends: ${misc:Depends}
Recommends: xz-utils
Build-Profiles: <!stage1>
Description: GNU C Library: sources
 This package contains the sources and patches which are needed to
 build glibc.

Package: locales
Architecture: all
Section: localization
Priority: standard
Depends: libc-bin (>> 2.43), libc-l10n (>> 2.43), ${misc:Depends}, debconf | debconf-2.0
Build-Profiles: <!stage1>
Description: GNU C Library: National Language (locale) data [support]
 Machine-readable data files, shared objects and programs used by the
 C library for localization (l10n) and internationalization (i18n) support.
 .
 This package contains tools to generate locale definitions from source
 files (included in this package). It allows you to customize which
 definitions actually get generated. This is a space-saver over how this
 package used to be, with all locales generated by default. This created
 a package that unpacked to an excess of 30 megs.

Package: locales-all
Architecture: any
Section: localization
Priority: optional
Multi-Arch: foreign
Depends: libc-l10n (>> 2.43), ${misc:Depends}
Build-Profiles: <!stage1>
Description: GNU C Library: Precompiled locale data
 This package contains the precompiled locale data for all supported locales.
 A better alternative is to install the locales package and only select
 desired locales, but it can be useful on a low-memory machine because some
 locale files take a lot of memory to be compiled.

Package: nscd
Architecture: any
Section: admin
Multi-Arch: foreign
Priority: optional
Depends: ${shlibs:Depends}, ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Conflicts: unscd
Build-Profiles: <!stage1 !stage2>
Description: GNU C Library: Name Service Cache Daemon
 A daemon which handles passwd, group and host lookups
 for running programs and caches the results for the next
 query. You should install this package only if you use
 slow services like LDAP, NIS or NIS+.

Package: libc6
Architecture: amd64 arc arm64 armel armhf hppa i386 loong64 m68k mips mipsel mipsn32 mipsn32el mips64 mips64el mipsr6 mipsr6el mipsn32r6 mipsn32r6el mips64r6 mips64r6el nios2 powerpc ppc64 ppc64el riscv64 sparc sparc64 s390x sh3 sh4 x32
Section: libs
Priority: optional
Multi-Arch: same
Depends: ${shlibs:Depends}, ${libgcc:Depends}, ${libc-gconv-modules-extra:Depends}
Recommends: libidn2-0 (>= 2.0.5~)
Suggests: glibc-doc, debconf | debconf-2.0, libc-l10n, locales [!hurd-any], libnss-nis, libnss-nisplus
Provides: libc6-sparcv9b [sparc sparc64], libc0.3-i686 [hurd-i386], libc6-i686 [i386]
Conflicts: libc6-i686 [i386], libc6.1-alphaev67 [alpha]
Breaks: nscd (<< 2.43), locales (<< 2.43), locales-all (<< 2.43), sysvinit-core (<< 3.09-2~), sysvinit (<< 3.09-2~), base-files (<< 13.3~), openssh-server (<< 1:9.9p1-3+hurd.1) [hurd-amd64], dhcpcd (<< 1:10.1.0-7~), pd-scaf (<< 1:0.14.1+darcs20180201-6+b4), postgresql-15-pllua (<< 1:2.0.12-4), postgresql-17-pllua (<< 1:2.0.12-3+b2), librccl1 (<< 5.4.3-3+b1), libamdhip64-5 (<< 5.7.1-5+b1), libhiprtc-builtins5 (<< 5.7.1-5+b1), lua-swupdate (<< 2024.12.1+dfsg-1+b3), libswupdate0.1 (<< 2024.12.1+dfsg-1+b3), uwsgi-plugin-pypy3 (<< 0.0.2+b1), python3-onnxruntime (<< 1.20.1+dfsg-2~), libde265-0 (<< 1.0.15-1+b3) [armel armhf], libmad0 (<< 0.15.1b-11+b1) [armel armhf], libx264-164 (<< 2:0.164.3108+git31e19f9-2+b1) [armel armhf], doublecmd-gtk (<< 1.1.22-1+b1) [armel armhf], doublecmd-plugins (<< 1.1.22-1+b1) [armel armhf], doublecmd-qt (<< 1.1.22-1+b1) [armel armhf], libmpeg2-4 (<<  0.5.1-9+b3) [armel armhf], libne10-10t64 (<< 1.2.1-5.1+b2) [armhf], libpdbg5 (<< 3.5-1+b1) [armel], libopenblas0-openmp (<< 0.3.29+ds-2+b1) [armhf s390x], libopenblas0-pthread (<< 0.3.29+ds-2+b1) [armhf s390x], libopenblas0-serial (<< 0.3.29+ds-2+b1) [armhf s390x], libopenblas64-0-openmp (<< 0.3.29+ds-2+b1) [s390x], libopenblas64-0-pthread (<< 0.3.29+ds-2+b1) [s390x], libopenblas64-0-serial (<< 0.3.29+ds-2+b1) [s390x], libfec0 (<< 1.0-26-gc5d935f-1+b3) [i386], python3-mrgingham (<< 1.25-1), linux-perf (<< 6.12.16-1) [armel], libqt6webenginecore6 (<< 6.8.2+dfsg-3) [i386]
Replaces: libc6-amd64 [amd64],
          libc6-i386 [i386],
          libc0.3-i686 [hurd-i386],
          libc6-i686 [i386],
          libc6-x32 [x32],
          libc6-powerpc [powerpc],
          libc6-ppc64 [ppc64],
          libc6-s390x [s390x],
          libc6-sparc64 [sparc64],
          libc6-mips64 [mips64 mips64el],
          libc6-mipsn32 [mipsn32 mipsn32el],
          libc6-mips32 [mips mipsel],
          hurd (<< 20120408-3) [hurd-i386]
Build-Profiles: <!stage1>
Description: GNU C Library: Shared libraries
 Contains the standard libraries that are used by nearly all programs on
 the system. This package includes shared versions of the standard C library
 and the standard math library, as well as many others.

Package: libc6-dev
Architecture: amd64 arc arm64 armel armhf hppa i386 loong64 m68k mips mipsel mipsn32 mipsn32el mips64 mips64el mipsr6 mipsr6el mipsn32r6 mipsn32r6el mips64r6 mips64r6el nios2 powerpc ppc64 ppc64el riscv64 sparc sparc64 s390x sh3 sh4 x32
Section: libdevel
Priority: optional
Multi-Arch: same
Depends: libc6 (= ${binary:Version}) <!stage1>, libc-dev-bin (= ${binary:Version}), ${misc:Depends}, linux-libc-dev [linux-any], gnumach-dev [hurd-any], hurd-dev [hurd-any] | hurd-headers-dev [hurd-any], ${rpcsvc-proto:Depends}
Suggests: glibc-doc, manpages-dev
Provides: libc-dev (= ${binary:Version}), libc6-dev [alpha hurd-any]
Breaks: ${libc-dev:Breaks}, check (<< 0.15.2-2+b1) [s390x], libmysqlclient-dev (<= 8.0.29-1), catch (<< 1.12.2-0.1), libdpkg-perl (<< 1.23.0) [i386]
Conflicts: libc6.1-dev, libc0.3-dev,
Description: GNU C Library: Development Libraries and Header Files
 Contains the symlinks, headers, and object files needed to compile
 and link programs which use the standard C library.

Package: libc6-dbg
Architecture: amd64 arc arm64 armel armhf hppa i386 loong64 m68k mips mipsel mipsn32 mipsn32el mips64 mips64el mipsr6 mipsr6el mipsn32r6 mipsn32r6el mips64r6 mips64r6el nios2 powerpc ppc64 ppc64el riscv64 sparc sparc64 s390x sh3 sh4 x32
Section: debug
Priority: optional
Multi-Arch: same
Provides: libc-dbg, libc6-dbgsym
Depends: libc6 (= ${binary:Version}), ${misc:Depends}
Build-Profiles: <!stage1>
Description: GNU C Library: detached debugging symbols
 This package contains the detached debugging symbols for the GNU C
 library.

Package: libc6-udeb
Package-Type: udeb
Architecture: amd64 arc arm64 armel armhf hppa i386 loong64 m68k mips mipsel mipsn32 mipsn32el mips64 mips64el mipsr6 mipsr6el mipsn32r6 mipsn32r6el mips64r6 mips64r6el nios2 powerpc ppc64 ppc64el riscv64 sparc sparc64 s390x sh3 sh4 x32
Section: debian-installer
Priority: optional
Provides: libc6, libc-udeb, libnss-dns-udeb, libnss-files-udeb
Build-Profiles: <!noudeb !stage1>
Description: GNU C Library: Shared libraries - udeb
 Contains the standard libraries that are used by nearly all programs on
 the system. This package includes shared versions of the standard C library
 and the standard math library, as well as many others.
 .
 This package contains a minimal set of libraries needed for the Debian
 installer.  Do not install it on a normal system.

Package: libc6.1
Architecture: alpha
Section: libs
Priority: optional
Multi-Arch: same
Depends: ${shlibs:Depends}, ${libgcc:Depends}, ${libc-gconv-modules-extra:Depends}
Recommends: libidn2-0 (>= 2.0.5~)
Suggests: glibc-doc, debconf | debconf-2.0, libc-l10n, locales [!hurd-any], libnss-nis, libnss-nisplus

=== debian/rules ===
#! /usr/bin/make -f
# -*- makefile -*-
# debian/rules file for GNU libc.
# Copyright 1998, 1999 by Joel Klecker <espy@debian.org>
# Copyright 2000-2004 Ben Collins <bcollins@debian.org>
# Copyright 2002-2004 Jeff Bailey <jbailey@debian.org>
# Copyright 2002-2005 Philip Blundell <pb@debian.org>
# Copyright 2002-2006 Daniel Jacobowitz <dan@debian.org>
# Copyright 2002-2006 GOTO Masanori <gotom@debian.org>
# Copyright 2006 Denis Barbier <barbier@debian.org>
# Copyright 2006-2025 Aurelien Jarno <aurel32@debian.org>
# Copyright 2007-2008 Pierre Habouzit <madcoder@debian.org>
# Copyright 2010-2013 Clint Adams <clint@debian.org>
# Copyright 2012-2019 Adam Conrad <adconrad@0c3.net>
# Copyright 2016-2025 Samuel Thibault <sthibault@debian.org>
# This Makefile is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.

# What are the phases to building glibc?

# Unpack main tarball
# Do any necessary overlays
# Apply patches
# Determine how many builds there are to do.  For Each build:

#  Create build directory
#  Configure
#  Build
#  Test as desired
#  Install to package directories

# Run debian magic to build packages.

# Things you may need to customise:

# These are done as absolute paths so that in the case of filesystem size
# limitations, they can be overridden and spread all over.
build-tree := build-tree
debian-tmp = debian/tmp$(filter-out -libc,-$(curpass))
stamp := $(CURDIR)/stamp-dir/
DUMMY := $(shell mkdir -p $(stamp))

# Beyond here you shouldn't need to customise anything:
include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/pkg-info.mk

# The minimum package version with which these packages are compatible.
shlib_dep_ver = $(DEB_VERSION_UPSTREAM)
shlib_dep = $(libc) (>= $(shlib_dep_ver))

DEB_BUILDDIR ?= $(build-tree)/$(DEB_HOST_ARCH)-$(curpass)
DEB_BUILDDIRLIBC ?= $(build-tree)/$(DEB_HOST_ARCH)-libc

GLIBC_SOURCES = $(filter-out debian $(shell basename $(stamp)) $(build-tree), $(wildcard *))

# Support multiple makes at once based on number of processors
include /usr/share/dpkg/buildopts.mk
NJOBS := $(DEB_BUILD_OPTION_PARALLEL:%=-j%)

# use the package settings, not the settings from the environment
define unsetenv
  unexport $(1)
  $(1) =
endef
$(foreach v, CPPFLAGS CFLAGS CXXFLAGS LDFLAGS, $(if $(filter environment,$(origin $(v))),$(eval $(call unsetenv, $(v)))))

# export debhelper substitution variables
export $(build-tree)

# Default setup
GLIBC_PASSES ?= libc

prefix=/usr
bindir=$(prefix)/bin
datadir=$(prefix)/share
complocaledir=$(prefix)/lib/locale
sysconfdir=/etc
libexecdir=$(prefix)/lib
rootsbindir=/sbin
includedir=$(prefix)/include
docdir=$(prefix)/share/doc
mandir=$(prefix)/share/man
sbindir=$(prefix)/sbin
vardbdir=/var/lib/misc
rtlddir=/lib
slibdir=/lib/$(DEB_HOST_MULTIARCH)
libdir=/usr/lib/$(DEB_HOST_MULTIARCH)
mvec = no

rtld_so=$(shell awk 'BEGIN {FS="="} /^ld\.so-version/ {print $$2}' $(DEB_BUILDDIR)/soversions.mk)
rtld_target=$(shell readlink $(debian-tmp)$(rtlddir)/$(rtld_so))
libc_so=$(shell awk 'BEGIN {FS="="} /^libc\.so-version/ {print "libc.so"$$2}' $(DEB_BUILDDIR)/soversions.mk)

BASE_CC = gcc
BASE_CXX = g++
BASE_MIG = mig
# If you override DEB_GCC_VERSION, consider adding DEB_CFLAGS_APPEND=-Wno-error.
DEB_GCC_VERSION ?= -15

RUN_TESTSUITE = yes
TIMEOUTFACTOR = 25

# Set cross and native compiler names, including version.
CC     = $(DEB_HOST_GNU_TYPE)-$(BASE_CC)$(DEB_GCC_VERSION)
CXX    = $(DEB_HOST_GNU_TYPE)-$(BASE_CXX)$(DEB_GCC_VERSION)
MIG    = $(DEB_HOST_GNU_TYPE)-$(BASE_MIG)
BUILD_CC = $(DEB_BUILD_GNU_TYPE)-$(BASE_CC)
BUILD_CXX = $(DEB_BUILD_GNU_TYPE)-$(BASE_CXX)

BUILD_CFLAGS = -O2 -g -fdebug-prefix-map=$(CURDIR)=.
HOST_CFLAGS = -pipe -O2 -g -fdebug-prefix-map=$(CURDIR)=. $(call xx,extra_cflags)

# 32-bit MIPS builders have a 2GB memory space. This is not enough to
# build test-tgmath3.o with GCC, unless tweaking the garbage collector.
ifeq ($(findstring mips,$(DEB_BUILD_ARCH))-$(DEB_BUILD_ARCH_BITS), mips-32)
  CC += --param ggc-min-expand=10
endif

configure_target := $(DEB_HOST_GNU_TYPE)

# Normally we'll just use this for --build.  If the architecture requires
# that build daemons be able to run a particular optimized library, then
# they can set the --build to match --host for that optimized build.
# Among other things this lets tests run.
configure_build := $(DEB_BUILD_GNU_TYPE)

# Which build pass are we on?
curpass = $(filter-out %_,$(subst _,_ ,$@))

ifneq ($(filter stage1,$(DEB_BUILD_PROFILES)),)
  DEB_ARCH_REGULAR_PACKAGES = $(libc)-dev
  DEB_INDEP_REGULAR_PACKAGES =
  DEB_UDEB_PACKAGES =
  ifeq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
    DEB_BUILD_OPTIONS+=nocheck
  endif
else
  DEB_ARCH_REGULAR_PACKAGES = $(libc) $(libc)-dev $(libc)-dbg libc-bin libc-dev-bin libc-gconv-modules-extra
  ifeq ($(filter stage2,$(DEB_BUILD_PROFILES)),)
    DEB_ARCH_REGULAR_PACKAGES += libc-devtools
  endif
  DEB_INDEP_REGULAR_PACKAGES = glibc-doc glibc-source libc-l10n locales
  ifneq ($(filter noudeb,$(DEB_BUILD_PROFILES)),)
    DEB_UDEB_PACKAGES =
  else
    DEB_UDEB_PACKAGES = $(libc)-udeb
  endif
  ## Locales can only be pre-generated during native compiles
  ifeq ($(DEB_HOST_ARCH),$(DEB_BUILD_ARCH))
    DEB_ARCH_REGULAR_PACKAGES += locales-all
  endif
endif

# Generic kernel version check
define kernel_check
(if [ $(CURRENT_KERNEL_VERSION) -lt $(1) ]; then \
  false; \
fi)
endef

# Include libidn for both NPTL and FBTL targets.
standard-add-ons = libidn,

# Pull in all the per-arch magic!

-include debian/sysdeps/$(DEB_HOST_ARCH_OS).mk
-include debian/sysdeps/$(DEB_HOST_ARCH).mk

ifneq ($(filter stage1,$(DEB_BUILD_PROFILES)),)
DEB_ARCH_REGULAR_PACKAGES += $(foreach p,$(DEB_ARCH_MULTILIB_PACKAGES), $(if $(findstring -dev,$(p)), $(p)))
else
DEB_ARCH_REGULAR_PACKAGES += $(DEB_ARCH_MULTILIB_PACKAGES)
endif

# Don't run dh_strip on this package
NOSTRIP_$(libc)-dbg = 1

# Put the debug files from these packages in $(libc)-dbg
DEBUG_$(libc) = 1

ifeq ($(filter stage1 stage2,$(DEB_BUILD_PROFILES)),)
  ifeq ($(threads),yes)
  DEB_ARCH_REGULAR_PACKAGES += nscd
  endif
endif

# And now the rules...
include debian/rules.d/*.mk

clean:: unpatch
	rm -rf $(patsubst %,debian/tmp-%,$(GLIBC_PASSES))
	rm -rf $(build-tree)
	rm -rf $(stamp)
	rm -rf debian/include

# Required Debian targets
build-arch: $(stamp)info \
	$(patsubst %,$(stamp)build_%,$(GLIBC_PASSES)) \
	$(patsubst %,$(stamp)check_%,$(GLIBC_PASSES)) \
	build-arch-post-check

ifeq ($(filter stage1,$(DEB_BUILD_PROFILES)),)
build-arch: $(stamp)build_C.utf8 \
	$(stamp)build_locales-all
endif

build-indep: $(stamp)source $(stamp)build_libc

build: build-arch build-indep


binary-indep: build-indep testroot debian/control $(build-tree) \
	$(patsubst %,$(stamp)binaryinst_%,$(DEB_INDEP_REGULAR_PACKAGES))

binary-arch: build-arch testroot debian/control $(build-tree) \
	$(patsubst %,$(stamp)binaryinst_%,$(DEB_ARCH_REGULAR_PACKAGES)) \
	$(patsubst %,$(stamp)binaryinst_%,$(DEB_UDEB_PACKAGES))

binary: binary-indep binary-arch

testroot:
	dh_testroot
